   TITLE Generuj zvuk na PC SPEAKERU
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   BEEP.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  :  Procedura prostednictvm druhho asovae generuje
'    dan tn.

' Voln(nap.) :  mov  bx, 10              ; Dlka tnu (v 1/64 sekundy)
'    mov  cx, 500             ; Koeficient frekvence
'                                           ; (1 193 180/frek. Hz)
'                  call  __beep             ; Generuj tn

' Mn registry :  Flags, AX, BX, CX
' 

' Odvolv se na:  PAUSE_MS.LIB
'    CPU_PAUS.LIB

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __beep               ; EXTRN __beep                :PROC :NEAR

   EXTRN  __pause_ms           :PROC :NEAR  ; {PAUSE_MS.LIB}
   EXTRN  __cpu_pause          :PROC :NEAR  ; {CPU_PAUS.LIB}


__beep  PROC  NEAR
     mov    al, 10110110B                   ; Aktivizace druhho asovae
     out    43H, al                         ; Odesln do pkazovho registru
     call   __cpu_pause                     ; asov prodleva CPU (5x JMP $+2)

     mov    al, cl                          ; Koef.frekvence - ni slabika
     out    42H, al                         ; Odesln na druh asova
     call   __cpu_pause                     ; asov prodleva CPU (5x JMP $+2)

     mov    al, ch                          ; Koef.frekvence - vy slabika
     out    42H, al                         ; Odesln na druh asova

     in     al, 61H                         ; Naten stavu portu
     mov    ah, al                          ; Uloen tohoto stavu
     or     al, 00000011B                   ; Zapnut zvuk. vstupu
     out    61H, al                         ; Odesln na port

Ton1:mov    cx, 2                           ; Hodnota pro dlku (1035 = 1/64 sekundy)
     call   __pause_ms                      ; ekej CX x (15.085 737 ms)
     dec    bx                              ; Jet jsme neskonily ?
     jnz    Ton1                            ; Ne, hrajeme dle

     in     al, 61H                         ; Naten stavu portu
     and    al, 11111100B
     out    61H, al

     retn                                   ; Nvrat NEAR
__beep  ENDP

Knihovna_NST32  ENDS
END
