   TITLE Funkce pro pevod selnch soustav ...
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   CONVERT.ASM
  Datum prav    :   27.08.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __con_bcd_b_ascii    ; EXTRN __con_bcd_b_ascii     :PROC :NEAR
   PUBLIC __con_bcd_w_ascii    ; EXTRN __con_bcd_w_ascii     :PROC :NEAR
   PUBLIC __con_byte_ascii     ; EXTRN __con_byte_ascii      :PROC :NEAR
   PUBLIC __con_word_ascii     ; EXTRN __con_word_ascii      :PROC :NEAR
   PUBLIC __con_dword_ascii    ; EXTRN __con_dword_ascii     :PROC :NEAR ; 386
   PUBLIC __con_byte_ascii_hex ; EXTRN __con_byte_ascii_hex  :PROC :NEAR
   PUBLIC __con_dword_ascii_hex; EXTRN __con_dword_ascii_hex :PROC :NEAR ; 386
   PUBLIC __con_word_ascii_hex ; EXTRN __con_word_ascii_hex  :PROC :NEAR
   PUBLIC __con_byte_ascii_bin ; EXTRN __con_byte_ascii_bin  :PROC :NEAR
   PUBLIC __con_word_ascii_bin ; EXTRN __con_word_ascii_bin  :PROC :NEAR
   PUBLIC __con_ascii_hex_word ; EXTRN __con_ascii_hex_word  :PROC :NEAR
   PUBLIC __con_ascii_hex_byte ; EXTRN __con_ascii_hex_byte  :PROC :NEAR
   PUBLIC __con_ascii_byte     ; EXTRN __con_ascii_byte      :PROC :NEAR
   PUBLIC __con_ascii_word     ; EXTRN __con_ascii_word      :PROC :NEAR
   PUBLIC __con_del_zero_dec   ; EXTRN __con_del_zero_dec    :PROC :NEAR
   PUBLIC __con_add_zero_dec   ; EXTRN __con_add_zero_dec    :PROC :NEAR


;'
;
;'Popis funkce  :  Peve slo BCD byte na ASCII
;'

;'Voln(nap.) :  mov  al, BCD BYTE        ; BCD BYTE slo pro peveden
;'   mov  si, OFFSET TXT      ; DS:SI etzec pro peloen slo
;'                 call __con_bcd_b_ascii   ; Convert BCD byte to ASCII

;'Vstup        :  DS:SI = pevedeno na 2 znaky ASCII
;'   AX    = pevedeny 2 znaky na ASCII

;'Mn registry :  Flags, AX
;'

;'

__con_bcd_b_ascii  PROC  NEAR
     push   cx                              ; Ulo reg.
     mov    cl, 4                           ; Bude se 4x rotovat
     mov    ah, al                          ; AH = Ni 4 bity
     shr    al, cl                          ; AL = Vy 4 bity
     and    ax, 0F0Fh
     add    ax, '00'                        ; Konvertuj do ASCII
     pop    cx                              ; Obnov reg.
     mov    word ptr ds:[si], ax            ; Ulo ASCII znak do etzce
     retn                                   ; Nvrat NEAR
__con_bcd_b_ascii  ENDP






;'
;
;'Popis funkce  :  Peve slo BCD WORD na ASCII.
;'   Pouv pro pevod funkci  __con_bcd_b_ascii.

;'Voln(nap.) :  mov  ax, BCD WORD        ; BCD WORD slo pro peveden
;'   mov  si, OFFSET TXT      ; DS:SI etzec pro peloen slo
;'                 call __con_bcd_w_ascii   ; Convert BCD word to ASCII

;'Vstup        :  DS:SI = pevedeno na 4 znaky ASCII
;'   AX    = pevedeny posledn 2 znaky na ASCII

;'Mn registry :  Flags, AX
;'

;'

__con_bcd_w_ascii  PROC  NEAR
     push   si ax                           ; Ulo reg.
     xchg   al, ah                          ; Proho reg.
     call   __con_bcd_b_ascii               ; Peve 1 st BCD
     add    si, 2                           ; Pozice v tislu
     pop    ax                              ; Peve AL
     xchg   ah, al                          ; Proho reg.
     call   __con_bcd_b_ascii               ; Peve 2 st BCD
     pop    si                              ; Obnov reg.
     retn                                   ; Nvrat NEAR
__con_bcd_w_ascii  ENDP






;'
;
;'Popis funkce  :  Peve slo BYTE na ASCII.
;'

;'Voln(nap.) :  mov  al, BYTE            ; BYTE slo pro peveden
;'   mov  si, OFFSET TXT      ; DS:SI etzec pro peloen slo
;'                 call __con_byte_ascii    ; Convert BYTE to ASCII

;'Vstup        :  DS:SI = pevedeno na 3 znaky ASCII
;'

;'Mn registry :  Flags
;'

;'

__con_byte_ascii  PROC  NEAR
     push   cx si ax                        ; Ulo reg.
     mov    cl, 100                         ; Potej stovky
     call   Peve_AL
     mov    cl, 10                          ; Potej destky
     call   Peve_AL
     call   AL_ASCII                        ; Potej jednotky
     pop    ax si cx                        ; Obnov reg.
     retn                                   ; Nvrat NEAR

Peve_AL:
     xor    ah, ah
     div    cl                              ; AL = AX / CL    (vsledek)
                                            ; AH = AX mod BL  (zbytek)
AL_ASCII:
     add    al, '0'                         ; AL = AL + '0' (korekce na ASCII)
     mov    byte ptr ds:[si], al            ; Ulo vsledek do etzce
     inc    si
     mov    al, ah                          ; Zbytek po dlen do AL
     retn                                   ; Nvrat NEAR
__con_byte_ascii  ENDP






;'
;
;'Popis funkce  :  Peve slo WORD na ASCII.
;'

;'Voln(nap.) :  mov  ax, WORD            ; WORD slo pro peveden
;'   mov  si, OFFSET TXT      ; DS:SI etzec pro peloen slo
;'                 call __con_word_ascii    ; Convert WORD to ASCII

;'Vstup        :  DS:SI = pevedeno na 5 znak ASCII
;'

;'Mn registry :  Flags
;'

;'

__con_word_ascii  PROC  NEAR
     push   ax cx dx si                     ; Ulo reg.
     mov    cx, 10000                       ; Potej desetitisce
     call   Peve_AX
     mov    cx, 1000                        ; Potej tisce
     call   Peve_AX
     mov    cx, 100                         ; Potej stovky
     call   Peve_AX
     mov    cx, 10                          ; Potej destky
     call   Peve_AX
     call   AX_ASCII                        ; Potej jednotky
     pop    si dx cx ax                     ; Obnov reg.
     retn                                   ; Nvrat NEAR

Peve_AX:
     xor    dx, dx
     div    cx                              ; AX = DX&AX / CX   (vsledek)
                                            ; DX = DX&AX mod CX (zbytek)
AX_ASCII:
     add    al, '0'                         ; AL = AL + '0' (korekce na ASCII)
     mov    byte ptr ds:[si], al            ; Ulo vsledek do etzce
     inc    si
     mov    ax, dx                          ; Zbytek po dlen do AX
     retn                                   ; Nvrat NEAR
__con_word_ascii  ENDP




   .386                                     ; Linkuje se pro 80 386

;'
;
;'Popis funkce  :  Peve slo DWORD na ASCII.
;'   Funkce jde pout pouze na procesorech 80 386 a vych !!!

;'Voln(nap.) :  mov  eax, DWORD          ; DWORD slo pro peveden
;'   mov  si, OFFSET TXT      ; DS:SI etzec pro peloen slo
;'                 call __con_dword_ascii   ; Convert DWORD to ASCII

;'Vstup        :  DS:SI = pevedeno na 10 znak ASCII
;'

;'Mn registry :  Flags
;'

;'

__con_dword_ascii  PROC  NEAR
     push   eax ecx edx si                  ; Ulo reg.
     mov    ecx, 1000000000
     call   Peve_EAX
     mov    ecx, 100000000
     call   Peve_EAX
     mov    ecx, 10000000
     call   Peve_EAX
     mov    ecx, 1000000
     call   Peve_EAX
     mov    ecx, 100000
     call   Peve_EAX
     mov    ecx, 10000
     call   Peve_EAX
     mov    ecx, 1000
     call   Peve_EAX
     mov    ecx, 100
     call   Peve_EAX
     mov    ecx, 10
     call   Peve_EAX
     call   EAX_ASCII                       ; Potej jednotky
     pop    si edx ecx eax                  ; Obnov reg.
     retn                                   ; Nvrat NEAR

Peve_EAX:
     xor    edx, edx
     div    ecx                             ; EAX = EDX&EAX / ECX   (vsledek)
                                            ; EDX = EDX&EAX mod ECX (zbytek)
EAX_ASCII:
     add    al, '0'                         ; AL = AL + '0' (korekce na ASCII)
     mov    byte ptr ds:[si], al            ; Ulo vsledek do etzce
     inc    si
     mov    eax, edx                        ; Zbytek po dlen do EAX
     retn                                   ; Nvrat NEAR

__con_dword_ascii  ENDP





   .8086                                    ; Linkuje se pro 80 86

;'
;
;'Popis funkce  :  Peve slo BYTE na HEX ASCII
;'

;'Voln(nap.) :  mov  al, BYTE            ; BYTE slo pro peveden
;'   mov  si, OFFSET TXT      ; DS:SI etzec pro peloen slo
;'                 call __con_byte_ascii_hex; Convert BYTE to HEX ASCII

;'Vstup        :  DS:SI = pevedeno na 2 znaky ASCII
;'

;'Mn registry :  Flags
;'

;'

__con_byte_ascii_hex  PROC  NEAR
     push   si cx ax ax                     ; Ulo reg.
     mov    cl, 4
     shr    al, cl                          ; 4x rotuj do prava
     call   ASCII_AL_HEX                    ; Peve AL na ASCII - vy bit.

     pop    ax
     and    al, 0Fh                         ; ni bit.
     call   ASCII_AL_HEX                    ; Pouij podprogram z WORD_HEX_ASCII
     pop    ax cx si                        ; Obnov reg.
     retn                                   ; Nvrat NEAR
__con_byte_ascii_hex  ENDP






;'
;
;'Popis funkce  :  Peve slo WORD na HEX ASCII
;'

;'Voln(nap.) :  mov  ax, WORD            ; WORD slo pro peveden
;'   mov  si, OFFSET TXT      ; DS:SI etzec pro peloen slo
;'                 call __con_word_ascii_hex; Convert WORD to HEX ASCII

;'Vstup        :  DS:SI = pevedeno na 4 znaky ASCII
;'

;'Mn registry :  Flags
;'

;'

__con_word_ascii_hex  PROC  NEAR
     push   ax cx si                        ; Ulo reg.
     xchg   al, ah                          ; Proho reg.
     call   Peve_AL_HEX                   ; Potej
     xchg   al, ah                          ; Proho reg.
     call   Peve_AL_HEX                   ; Potej
     pop    si cx ax                        ; Obnov reg.
     retn                                   ; Nvrat NEAR

Peve_AL_HEX:
     push   ax
     mov    cl, 4
     shr    al, cl                          ; 4x rotuj do prava
     call   ASCII_AL_HEX                    ; Peve AL na ASCII - vy bit.
     pop    ax
     and    al, 0Fh                         ; Ni bit.

ASCII_AL_HEX:
     add    al, '0'                         ; Piti
     cmp    al, '0'+10                      ; Je v AL znak ASCII ?
     jb     HEX_ASCII_ZNAK                  ; Ano,  sko
     add    al, 'A'-'0'-10                  ; Ne, piti ...

HEX_ASCII_ZNAK:
     mov    byte ptr ds:[si], al            ; Ulo HEX znak do etzce
     inc    si
     retn                                   ; Nvrat NEAR
__con_word_ascii_hex  ENDP



   .386                                     ; Linkuje se pro 80 386

;'
;
;'Popis funkce  :  Peve slo DWORD na HEX ASCII
;'   Funkce jde pout pouze na procesorech 80 386 a vych !!!

;'Voln(nap.) :  mov  eax, DWORD          ; DWORD slo pro peveden
;'   mov  si, OFFSET TXT      ; DS:SI etzec pro peloen slo
;'                 call __con_dword_ascii_hex; Convert WORD to HEX ASCII {jen 386}

;'Vstup        :  DS:SI = pevedeno na 8 znak ASCII
;'

;'Mn registry :  Flags, EAX, CX, SI
;'

;'

__con_dword_ascii_hex  PROC  NEAR
     push   eax cx si                       ; Ulo reg.
     rol    eax, 16                         ; Oto EAX
     xchg   al, ah                          ; Proho reg.
     call   Peve_AL_HEX                   ; Potej
     xchg   al, ah                          ; Proho reg.
     call   Peve_AL_HEX                   ; Potej

     rol    eax, 16                         ; Vra zpt EAX
     xchg   al, ah                          ; Proho reg.
     call   Peve_AL_HEX                   ; Potej
     xchg   al, ah                          ; Proho reg.
     call   Peve_AL_HEX
     pop    si cx eax                       ; Obnov reg.
     retn                                   ; Nvrat NEAR
__con_dword_ascii_hex  ENDP



   .8086                                    ; Linkuje se pro 80 86

;'
;
;'Popis funkce  :  Peve slo BYTE na BIN ASCII
;'

;'Voln(nap.) :  mov  al, BYTE            ; BYTE slo pro peveden
;'   mov  si, OFFSET TXT      ; DS:SI etzec pro peloen slo
;'                 call __con_byte_ascii_bin; Convert BYTE to BIN ASCII

;'Vstup        :  DS:SI = pevedeno na 8 znak ASCII
;'

;'Mn registry :  Flags, AX
;'

;'

__con_byte_ascii_bin  PROC  NEAR
     push   cx si                           ; Ulo reg.
     mov    cx, 8                           ; 8-bit
ROTUJ_AL:
     shl    al, 1                           ; Rotuj do leva
     jc     AL_CF_1                         ; Je-li v CF 1 sko ...
     mov    byte ptr ds:[si], '0'           ; Ulo ASCII znak do etzce
     jmp    BBA_END

AL_CF_1:
     mov    byte ptr ds:[si], '1'           ; Ulo ASCII znak do etzce
BBA_END:
     inc    si
     loop   ROTUJ_AL
     pop    si cx                           ; Obnov pomocn reg.
     retn                                   ; Nvrat NEAR
__con_byte_ascii_bin  ENDP





;'
;
;'Popis funkce  :  Peve slo WORD na BIN ASCII
;'

;'Voln(nap.) :  mov  ax, WORD            ; WORD slo pro peveden
;'   mov  si, OFFSET TXT      ; DS:SI etzec pro peloen slo
;'                 call __con_word_ascii_bin; Convert WORD to BIN ASCII

;'Vstup        :  DS:SI = pevedeno na 16 znak ASCII
;'

;'Mn registry :  Flags, AX
;'

;'

__con_word_ascii_bin  PROC  NEAR
     push   cx si                           ; Ulo pomocn reg.
     mov    cx, 16                          ; 16-bit
ROTUJ_AX:
     shl    ax, 1                           ; Rotuj do leva
     jc     AX_CF_1                         ; Je-li v CF 1 sko ...
     mov    byte ptr ds:[si], '0'           ; Ulo ASCII znak do etzce
     jmp    WBA_END

AX_CF_1:
     mov    byte ptr ds:[si], '1'           ; Ulo ASCII znak do etzce

WBA_END:
     inc    si
     loop   ROTUJ_AX
     pop    si cx                           ; Obnov pomocn reg.
     retn                                   ; Nvrat NEAR
__con_word_ascii_bin  ENDP





;'
;
;'Popis funkce  :  Peve HEX ASCII na slo BYTE
;'

;'Voln(nap.) :  mov  si, OFFSET TXT      ; DS:SI etzec pro pevod
;'   call __con_ascii_hex_byte; Convert HEX ASCII to BYTE

;'Vstup        :  mov  al, BYTE            ; BYTE slo po peveden z HEX ASCII
;'

;'Mn registry :  Flags, AX
;'

;'

__con_ascii_hex_byte  PROC  NEAR
     push   cx dx si                        ; Ulo reg.
     xor    dx, dx                          ; Pomocn reg.
     mov    cl, 4                           ; Rotace 4x
     lodsb                                  ; Nati HEX znak z etzce (?0H)
     call   AL_HEX_ASCII
     lodsb                                  ; Nati HEX znak z etzce (0?H)
     call   AL_HEX_ASCII
     mov    ax, dx
     ror    ax, cl
     pop    si dx cx                        ; Obnov reg.
     xor    ah, ah                          ; AH = 0000
     retn                                   ; Nvrat NEAR

AL_HEX_ASCII:
     sub    al, '0'                         ; Odeti ASCII
     cmp    al, 10                          ; Je v AL slo 0-9 ?
     jb     ASCII_ZNAK                      ; Ano,  sko
     sub    al, 'A'-'0'-10                  ; Ne, odeti ...
ASCII_ZNAK:
     add    dl, al
     rol    dx, cl
     retn                                   ; Nvrat NEAR
__con_ascii_hex_byte  ENDP





;'
;
;'Popis funkce  :  Peve HEX ASCII na slo WORD
;'

;'Voln(nap.) :  mov  si, OFFSET TXT      ; DS:SI etzec pro pevod
;'   call __con_ascii_hex_word; Convert HEX ASCII to WORD

;'Vstup        :  mov  ax, WORD            ; WORD slo po peveden z HEX ASCII
;'

;'Mn registry :  Flags, AX
;'

;'

__con_ascii_hex_word  PROC  NEAR
     push   cx dx si                        ; Ulo reg.
     xor    dx, dx                          ; Pomocn reg.
     mov    cl, 4                           ; Rotace 4x
     lodsb                                  ; Nati HEX znak z etzce (?000H)
     call   AL_HEX_ASCII
     lodsb                                  ; Nati HEX znak z etzce (0?00H)
     call   AL_HEX_ASCII
     lodsb                                  ; Nati HEX znak z etzce (00?0H)
     call   AL_HEX_ASCII
     lodsb                                  ; Nati HEX znak z etzce (000?H)
     call   AL_HEX_ASCII
     mov    ax, dx
     ror    ax, cl
     pop    si dx cx                        ; Obnov reg.
     retn                                   ; Nvrat NEAR
__con_ascii_hex_word  ENDP



;'
;
;'Popis funkce  :  Peve 3 ASCII na slo BYTE
;'

;'Voln(nap.) :  mov  si, OFFSET TXT      ; DS:SI etzec pro pevod
;'   call __con_ascii_byte    ; Convert ASCII to BYTE

;'Vstup        :  mov  al, BYTE            ; BYTE slo po peveden z ASCII
;'

;'Mn registry :  Flags, AX
;'

;'

__con_ascii_byte  PROC  NEAR
     push   dx cx si                        ; Ulo reg.
     xor    dx, dx                          ; DX = 0000
     call   Nati_BYTE                      ; Nati ASCII a konvertuj jej do AL
     mov    cl, 100                         ; Potej stovky
     call   ASCII_AL
     call   Nati_BYTE                      ; Nati ASCII a konvertuj jej do AL
     mov    cl, 10                          ; Potej stovky
     call   ASCII_AL
     call   Nati_BYTE                      ; Nati ASCII a konvertuj jej do AL
     mov    cl, 1                           ; Potej stovky
     call   ASCII_AL
     mov    al, dl
     xor    ah, ah                          ; AH = 00
     pop    si cx dx                        ; Obnov reg.
     retn                                   ; Nvrat NEAR

ASCII_AL:
     xor    ah, ah
     mul    cl                              ; AL = AX * CL    (vsledek)
                                            ; AH = AX mod CL   (zbytek)
     add    dl, al
     retn                                   ; Nvrat NEAR

Nati_BYTE:
     mov    al, byte ptr [si]               ; Nati ASCII znak
     cmp    al, ' '                         ; Je to Mezera ?
     jne    Ne_Mez                          ; Ne, sko ...
     mov    al, '0'                         ; Dopl mezeru nulou
Ne_Mez:inc  si                              ; Dal znak ...
     sub    al, '0'                         ; AL = AL - '0' (korekce z ASCII na BYTE)
     retn                                   ; Nvrat NEAR
__con_ascii_byte  ENDP



;'
;
;'Popis funkce  :  Peve 5 ASCII na slo WORD
;'

;'Voln(nap.) :  mov  si, OFFSET TXT      ; DS:SI etzec pro pevod
;'   call __con_ascii_word    ; Convert ASCII to WORD

;'Vstup        :  mov  ax, WORD            ; WORD slo po peveden z ASCII
;'

;'Mn registry :  Flags, AX
;'

;'

__con_ascii_word  PROC  NEAR
     push   bx cx dx si                     ; Ulo reg.
     xor    bx, bx                          ; BX = 0000
     call   Nati_WORD                      ; Nati ASCII a konvertuj jej do AL
     mov    cx, 10000                       ; Potej deseti-tisce
     call   ASCII_AX
     call   Nati_WORD                      ; Nati ASCII a konvertuj jej do AL
     mov    cx, 1000                        ; Potej tisce
     call   ASCII_AX
     call   Nati_WORD                      ; Nati ASCII a konvertuj jej do AL
     mov    cx, 100                         ; Potej stovky
     call   ASCII_AX
     call   Nati_WORD                      ; Nati ASCII a konvertuj jej do AL
     mov    cx, 10                          ; Potej stovky
     call   ASCII_AX
     call   Nati_WORD                      ; Nati ASCII a konvertuj jej do AL
     mov    cx, 1                           ; Potej stovky
     call   ASCII_AX
     mov    ax, bx                          ; AX <= BX
     pop    si dx cx bx                     ; Obnov reg.
     retn                                   ; Nvrat NEAR

ASCII_AX:
     xor    ah, ah
     mul    cx                              ; AL = AX * CL    (vsledek)
                                            ; AH = AX mod CL   (zbytek)
     add    bx, ax                          ; Piti k BX
     retn                                   ; Nvrat NEAR

Nati_WORD:
     mov    al, byte ptr [si]               ; Nati ASCII znak
     cmp    al, ' '                         ; Je to Mezera ?
     jne    Ne_MezX                         ; Ne, sko ...
     mov    al, '0'                         ; Dopl mezeru nulou
Ne_MezX:inc  si                             ; Dal znak ...
     sub    al, '0'                         ; AL = AL - '0' (korekce z ASCII na BYTE)
     retn                                   ; Nvrat NEAR
__con_ascii_word  ENDP




;'
;
;'Popis funkce  :  V etzci DS:SI po pevodu odmae nuly (zleva do prava).
;'   (POZOR !  To plat pouze pro DEC. soustavu)

;'Voln(nap.) :  mov  cx, 2               ; Poet desetinch mst
;'                            ; BYTE  = 2
;'                                          ; WORD  = 4
;'                                          ; DWORD = 9
;'                 mov  si, OFFSET TXT      ; DS:SI etzec po pevodu
;'                 call __con_del_zero_dec  ; Sma nuly po pevodu

;'Vstup        :  DS:SI                    ; Peveden etzec bez nul
;'

;'Mn registry :  Flags
;'

;'

__con_del_zero_dec  PROC  NEAR
     push   cx si                           ; Ulo reg.

Null_Z:
     cmp    byte ptr [si], '0'              ; Je to '0' ?
     jne    No_Zero                         ; Ne, sko ...
     mov    byte ptr [si], ' '              ; Vlo mezeru msto nuly
     inc    si                              ; Dal ASCII znak
     loop   Null_Z                          ; Opkauj smyku

No_Zero:
     pop    si cx                           ; Obnov reg.
     retn                                   ; Nvrat NEAR
__con_del_zero_dec  ENDP



;'
;
;'Popis funkce  :  V etzci DS:SI ped pevodem nahrad mezery nulou (zleva do prava).
;'   (POZOR !  To plat pouze pro DEC. soustavu)

;'Voln(nap.) :  mov  cx, 2               ; Poet desetinch mst
;'                            ; BYTE  = 2
;'                                          ; WORD  = 4
;'                                          ; DWORD = 9
;'                 mov  si, OFFSET TXT      ; DS:SI etzec po pevodu
;'                 call __con_add_zero_dec  ; Nahra mezery nulou

;'Vstup        :  DS:SI                    ; Peveden etzec s nulami
;'

;'Mn registry :  Flags
;'

;'

__con_add_zero_dec  PROC  NEAR
     push   cx si                           ; Ulo reg.

Null_Z1:
     cmp    byte ptr [si], ' '              ; Je to mezera ?
     jne    No_Zero1                        ; Ne, sko ...
     mov    byte ptr [si], '0'              ; Vlo msto mezeru nulu
     inc    si                              ; Dal ASCII znak
     loop   Null_Z1                         ; Opkauj smyku

No_Zero1:
     pop    si cx                           ; Obnov reg.
     retn                                   ; Nvrat NEAR
__con_add_zero_dec  ENDP


Knihovna_NST32  ENDS
END
