   TITLE Test na ptomnost CD-ROM
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   D_CDROM.ASM
  Datum prav    :   01.09.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  : Tato procedura testuje ptomnost CR-ROM jednotky.
'   Program je napsn podle Progromtorsk Perliky v
'                 asopise BAJT Leden 1994, str. 139

' Voln(nap.) :  mov  cl, 'G'             ; Jmno testovanho disku
'    call __detect_cdrom      ; Test na ptomnost CR-ROM

' Vstup        :  CF = 1  Je podporovno CD-ROM
'    CF = 0  Nen podporovno CD-ROM
'
'

' Mn registry :  Flags, AX, BX, CX
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_cdrom       ; EXTRN __detect_cdrom        :PROC :NEAR


__detect_cdrom  PROC  NEAR
     xor    bx, bx                          ; Piprav nvratovou hodnotu
     mov    ax, 1500h                       ; Je ptomen MSCDEX nebo jeho ekvivalent ?
     int    2Fh                             ; Volej obslun peruen
     mov    ax, bx                          ; Ulo nvratov kd
     or     ax, ax                          ; Pokud BX = 0 nen MSCDEX instalovn
     jz     No_CDROM                        ; Konec ...

     mov    ax, 150Bh                       ; API pro MSCDEX: check drive
     sub    cl, 'A'                         ; CL vstup.hodnota. Jmno disku A-Z
     mov    ch, 0                           ; Poadovan je binrn jmno A:=0, B:=1, ...
     int    2Fh                             ; Volej obslun peruen

     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR

No_CDROM:
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR
__detect_cdrom  ENDP

Knihovna_NST32  ENDS
END
