   TITLE Test na ptomnost Monochrom (nebo Hercules) monitor ...
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   D_MH_MON.ASM
  Datum prav    :   19.06.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  : Tato procedura testuje, zda-li je instalovn Monochrom
'   (nebo Hercules) monitor.

' Voln(nap.) :  call __detect_mc_monitor      ; Test na Monochrom & Hercules
' 

' Vstup        :  CF = 1  Je instalovn Monochrom nebo Hercules
'    CF = 0  Nen Hercules ani Monochrom

' Mn registry :  Flags, AX
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_mc_monitor  ; EXTRN __detect_mc_monitor   :PROC :NEAR



__detect_mc_monitor  PROC  NEAR

;  { Test Monochrom nebo Hercules pomoc INT 11h }
     int    11h                             ; Zjisti konfiguraci systmu
     and    ax, 0000000000110000B
     cmp    ax, 0000000000110000B           ; Je reim MONOCHROM nebo Herc. ?
     je     Ok_Herc                         ; Ano, sko ...

;         { Konec - Vstupn hlen }
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR

Ok_Herc:
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR

__detect_mc_monitor  ENDP

Knihovna_NST32  ENDS
END
