   TITLE Test na ptomnost ovladae MOUSE
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   D_MOUSE.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  : Tato procedura testuje ptomnost MOUSE. Je-li instalovna,
'   nastav jej souadnice na dek a sloupec .1.

' Voln(nap.) :  call __detect_mouse      ; Test na ptomnost mouse
' 

' Vstup        :  CF = 1  Je instalovna MOUSE
'    CF = 0  Nen instalovna
'                  BX =    Poet tlatek v GM

' Mn registry :  Flags, AX, BX, CX, DX, ES
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_mouse       ; EXTRN __detect_mouse        :PROC :NEAR


__detect_mouse  PROC  NEAR
     mov    ax, 3533h                       ; Zjisti adresy INT 33h
     int    21h
     mov    ax, es
     or     ax, bx                          ; Je vsledek nula ?
     jz     No_MOUSE                        ; Ano, sko ...

     xor    ax, ax                          ; RESET MOUSE
     int    33h
     or     ax, bx                          ; Je vsledek nula ?
     jz     No_MOUSE                        ; Ano, sko ...

     mov    ax, 04h                         ; Nastav Mouse na novou souadnici
     xor    cx, cx                          ; Sloupec
     mov    dx, cx                          ; dek
     int    33h
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR

No_MOUSE:
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR
__detect_mouse  ENDP

Knihovna_NST32  ENDS
END
