   TITLE Test na ptomnost RAMdisku
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   D_R-DISK.ASM
  Datum prav    :   01.09.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  : Tato procedura testuje ptomnost RAMdisku.
'   Program je napsn podle Progromtorsk Perliky v
'                 asopise BAJT Leden 1994, str. 139

' Voln(nap.) :  mov  cl, 'G'             ; Jmno testovanho disku
'    call __detect_ramdisk    ; Test na ptomnost RAMdisku

' Vstup        :  CF = 1  Je podporovno CD-ROM
'    CF = 0  Nen podporovno CD-ROM
'
'

' Mn registry :  Flags, AX, BX, CX, DX
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_ramdisk     ; EXTRN __detect_ramdisk      :PROC :NEAR


__detect_ramdisk  PROC  NEAR
     push   ds                              ; Ulo reg.
     mov    ah, 32h                         ; Nedokumentovan funkce
     mov    dl, cl                          ; Jmno disku ve tvaru A-Z
     sub    dl, 'A'-1                       ; Binrn jmno (1='A')
     int    21h                             ; Volej sloby DOSu
     xor    ax, ax                          ; Piprav nvratovou hodnotu
     cmp    byte ptr [bx+08], 1             ; Testuj poet FAT tabulek.
                                            ; DS je vrcen z voln DOSu
     je     No_RAMdisk                      ; Pokud je jen jedna tab.sko
     pop    ds                              ; Obnov reg.
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR

No_RAMdisk:
     pop    ds                              ; Obnov reg.
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR
__detect_ramdisk  ENDP

Knihovna_NST32  ENDS
END
