   TITLE Nate klvesy z klvesnice a ulo jej do etzce.
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   INPUT_T.ASM
  Datum prav    :   04.08.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  :  Pe volnm tohoto programu je nutn pout proc.
'    __read_ascii.  Ta vlo do AX a BX kd stiskl klvesy,
'                  kter se otestuj (Esc,Enter,F1 ...) a nen-li stiskl dc
'                  klvesa, prove skok na __input_text.

'                  Tato procedura pak ovld vekerou vlastn editaci a
'                  ulo ASCII do pamti (etzce).
'                  Po ukonen vrt zen volanmu programu.
'                  Nastav velikost kurzoru podle pedelho prosted ...


' Voln(nap.) :  call __read_ascii        ; ekej na ASCII z klvesnice
'           ...
'                  procedura pro test       ; AH = SCAN, AL = ASCII
'                   funknch klves        ; BX = dc klvesy
'                         ...
'                  mov  cx, 6               ; Dlka editanho oknka
'                  mov  dl, 10              ; dek editace   (1-25) textu
'                  mov  dh, 1               ; Sloupec editace (1-80) textu
'                  mov  si, OFFSET TXT      ; DS:SI Adr. etzce
'                  mov  di, 45              ; Max.dlka etzce
'                  call __input_text        ; Edituj v textu

;'Vstup        :  CX = max. velikost edit. dku
;'   DI = max. dlka edit.pole


' Mn registry :  Flags, ES, DI, CX
' 

' Odvolv se na:  R_ASCII.LIB
'    V_OFFS_T.LIB
'                  TEST_XY.LIB
'                  PAUSE_MS.LIB
'                  CPU_PAUS.LIB
'                  BEEP.LIB

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __input_text         ; EXTRN __input_text          :PROC :NEAR
   PUBLIC __aktual_poz_txt     ; EXTRN __aktual_poz_txt      :PROC :NEAR
   PUBLIC &__it_setup          ; EXTRN &__it_setup           :BYTE
   PUBLIC &__it_color_char     ; EXTRN &__it_color_char      :BYTE
   PUBLIC &__it_pos_kur        ; EXTRN &__it_pos_kur         :BYTE
   PUBLIC &__it_user_print     ; EXTRN &__it_user_print      :WORD
   PUBLIC &__it_user_kurzor    ; EXTRN &__it_user_kurzor     :WORD

   EXTRN __read_ascii          :PROC :NEAR  ; {R_ASCII.LIB}
   EXTRN __num_key_convert     :PROC :NEAR  ; {R_ASCII.LIB}
   EXTRN &__ra_setup           :BYTE        ; {R_ASCII.LIB}
   EXTRN &__ra_proc_user       :WORD        ; {R_ASCII.LIB}
   EXTRN __test_position_xy    :PROC :NEAR  ; {TEST_XY.LIB}
   EXTRN &__txy_size_row       :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size1_row      :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size_slow      :BYTE        ; {TEST_XY.LIB}
   EXTRN __video_offs_adr_t    :PROC :NEAR  ; {V_OFFS_T.LIB}
   EXTRN __video_seg_adr       :PROC :NEAR  ; {V_SEG.LIB}
   EXTRN __get_video_page      :PROC :NEAR  ; {V_BIOS.LIB}
   EXTRN __set_video_page      :PROC :NEAR  ; {V_BIOS.LIB}
   EXTRN __get_video_mode      :PROC :NEAR  ; {V_BIOS.LIB}
   EXTRN __get_cursor_pos      :PROC :NEAR  ; {V_BIOS.LIB}
   EXTRN __set_cursor_pos      :PROC :NEAR  ; {V_BIOS.LIB}
   EXTRN __set_cursor_size     :PROC :NEAR  ; {V_BIOS.LIB}
   EXTRN __beep                :PROC :NEAR  ; {BEEP.LIB}
   EXTRN __pause_ms            :PROC :NEAR  ; {PAUSE_MS.LIB}
   EXTRN __cpu_pause           :PROC :NEAR  ; {CPU_PAUS.LIB}



;        { Nastaven parametr v SETUPu }

&__it_setup   DB 00000010B        ; Nastaven pro Input ...
              ;' 
              ;' > 1 =
              ;' > 1 = Konec textu je realizovn pomoc '$' (jinak pla DI)
              ;' > 1 =
              ;' > 1 =
              ;' > 1 =
              ;' > 1 =
              ;' > 1 = Pouij pro umstn kurzoru User proc.
              ;' > 1 = Pouij pro tisk etzce User proc.

&__it_color_char   DB 0           ; [U] Barva etzce
&__it_pos_data     DW 01          ; Pozice v editovanch datech
&__it_pos_kur      DB 1           ; Pozice kurzoru na obrazovce
&__it_user_print   DW OFFSET NAVRAT    ; Offs. pro User proc. pro tisk etzce
&__it_user_kurzor  DW OFFSET NAVRAT    ; Offs. pro User proc. pro umstn kurzoru

NAVRAT:            RETN           ; Nvrat z przdn User proc.




;                     Ŀ
;                     {         __input_text           }
;                     

__input_text  PROC  NEAR
     cld                                         ; Zpracovn etzc
     push   ax                    ; (+15=AH) SCAN  key
                                  ; (+14=AL) ASCII key
     push   bx                    ; (+13=BH) Stav rozench dcch klves
                                  ; (+12=BL) Stav dcch klves

     push   cx                    ; (+11=CH) Dlka edit.dku (1-80)
                                  ; (+10=CL)    ---- " ------

     push   dx                    ; (+08=DX) Pozice ped korekc
     dec    dh                    ;'KOREKCE'
     dec    dl                    ;'KOREKCE'
     push   dx                    ; (+07=DH) Zatek sloupce okna (1-80)
                                  ; (+06=DL) Zatek dku okna   (1-25)
     push   si                    ; (+04=SI) OFFSET TEXTU

     push   di                    ; (+02=DI) Max. velikost '$' natvanch dat
     push   bp                    ; (+00=BP)

     mov    bp, sp                          ; Vrchol zsobnku
     call   __video_seg_adr                 ; Zjisti VIDEO-seg. a nastav dorazy







;                     Ŀ
;                     { Testuj dlku v textu (pomoc $)}
;                     

     test   byte ptr cs:[&__it_setup], 00000010B ; Nastaven pro Input ...
     jz     Test_DO                         ; Ne, sko ...
     xor    cx, cx                          ; CX = 0000

P_SD:cmp    byte ptr ds:[si], '$'           ; Je to konec dat ?
     je     End_Dat_$                       ; Ano, sko ...
     inc    si                              ; Adr. Textu
     inc    cx                              ; Dlka Textu
     jmp    P_SD                            ; Opakuj operaci znova

End_Dat_$:
     mov    word ptr [bp+02], cx            ; Max. velikost '$' natvanch dat





;                     Ŀ
;                     {   Testuj dlku na obrazovce    }
;                     

Test_DO:
     mov    cx, word ptr [bp+10]            ; Velikost zobrazenho editanho dku

TDP1:call   __test_position_xy              ; Test souadnic pro tisk
     jnc    Pos_End1                        ; Nejsou-li souadnice mimo, obrazovku, sko ...
     dec    word ptr [bp+10]                ; Velikost zobrazenho editanho dku

Pos_End1:
     inc    dh                              ; Sloupec editace (1-80) textu
     loop   TDP1                            ; Opakuj smyku



;                     Ŀ
;                     {  Testuj poz. kur. na obrazovce }
;                     
Test_Poz_Kur:
     xor    cx, cx                          ; CX = 0000
     mov    cl, byte ptr cs:[&__it_pos_kur] ; Pozice kurzoru na obrazovce
     cmp    cx, word ptr [bp+10]            ; Velikost zobrazenho editanho dku
     ja     Minus_Kur                       ; Je-li poz.kur.vt, sko ...
     jmp    Test_RK                         ; Pokrauj dle ...

Minus_Kur:
     dec    byte ptr cs:[&__it_pos_kur]     ; Pozice kurzoru na obrazovce
     jmp    Test_Poz_Kur                    ; Opakuj znovu test ...




;                     Ŀ
;                     {     Test na dc klvesy     }
;                     
Test_RK:

;                   { Home }
     cmp    ah, 47h                         ; Home ?
     jne    No_TRK1                         ; Ne, sko ...

     mov    dx, 0001
     mov    word ptr cs:[&__it_pos_data], dx; Pozice v editovanch datech
     mov    byte ptr cs:[&__it_pos_kur], dl ; Pozice kurzoru na obrazovce
     jmp    TT_DP                           ; Tiskni text na obrazovce

;                    { End }
No_TRK1:
     cmp    ah, 4Fh                         ; End ?
     jne    No_TRK2                         ; Ne, sko ...

     mov    dx, word ptr [bp+10]            ; Velikost zobrazenho editanho dku
     mov    byte ptr cs:[&__it_pos_kur], dl ; Pozice kurzoru na obrazovce

     mov    cx, word ptr [bp+02]            ; Max. velikost '$' natvanch dat
     mov    si, word ptr [bp+04]            ; OFFSET TXT
     add    si, cx                          ; Konec textu

     mov    word ptr cs:[&__it_pos_data], cx; Pozice v editovanch datech
     sub    word ptr cs:[&__it_pos_data], dx
     jcxz   End_E

OP_End:
     dec    si
     cmp    byte ptr ds:[si], ' '           ; Je mezera ?
     jne    OK_End                          ; Ne, sko ...
     loop   OP_End
     mov    word ptr cs:[&__it_pos_data], 1 ; Pozice v editovanch datech
     mov    byte ptr cs:[&__it_pos_kur], 1  ; Pozice kurzoru na obrazovce
     jmp    TT_DP                           ; Tiskni text na obrazovce



OK_End:
     cmp    cx, dx                          ; End etzce < dlka edit.dku
     jb     Ok_End_r
     sub    cx, dx
     inc    cx                              ;'KOREKCE'
     mov    word ptr cs:[&__it_pos_data], cx; Pozice v editovanch datech
End_E:jmp   TT_DP                           ; Tiskni text na obrazovce

Ok_End_r:
     mov    byte ptr cs:[&__it_pos_kur], cl ; Pozice kurzoru na obrazovce
     mov    word ptr cs:[&__it_pos_data], 1 ; Pozice v editovanch datech
     jmp    TT_DP                           ; Tiskni text na obrazovce

;       { Nereaguj na stisk klves: }
No_TRK2:
     push   ax di es                        ; Ulo reg.
     mov    di, cs                          ; DI <= CS
     mov    es, di                          ; ES <= DI

     mov    di, OFFSET Not_KEY
     mov    cx, 20                          ; Poet hledanch klves
     xchg   ah, al                          ; Proho klvesy
     repne  scasb                           ; Hledej znak v tabulce
     jne    No_Not_KEY                      ; Nen-li tam, sko ...
     pop    es di ax                        ; Obnov reg.
     jmp    TT_DP                           ; Tiskni text na obrazovce

No_Not_KEY:
     pop    es di ax                        ; Obnov reg.
     jmp    No_TRK3                         ; Pokrauj dl ...

Not_KEY:
    DB 01h        ; Esc
    DB 0Fh        ; Tab
    DB 1Ch        ; Enter
    DB 3Bh        ; F1
    DB 3Ch        ; F2
    DB 3Dh        ; F3
    DB 3Eh        ; F4
    DB 3Fh        ; F5
    DB 40h        ; F6
    DB 41h        ; F7
    DB 42h        ; F8
    DB 43h        ; F9
    DB 44h        ; F10
    DB 85h        ; F11
    DB 86h        ; F12
    DB 49h        ; Page Up
    DB 51h        ; Page Down
    DB 48h        ; ipka nahoru
    DB 50h        ; ipka dolu
    DB 52h        ; Insert

;               { ipka vlevo }
No_TRK3:
     cmp    ah, 4Bh                         ; ipka vlevo ?
     jne    No_TRK4                         ; Ne, sko ...

     call   Doraz_MIN_Poz_TXT               ; Testuj min. hodnoty TXT
     jmp    TT_DP                           ; Tiskni text na obrazovce

;               { ipka vpravo }
No_TRK4:
     cmp    ah, 4Dh                         ; ipka vpravo ?
     jne    No_TRK5                         ; Ne, sko ...

     inc    byte ptr cs:[&__it_pos_kur]     ; Pozice kurzoru na obrazovce
     mov    dx, word ptr [bp+10]            ; Velikost zobrazenho editanho dku
     cmp    dl, byte ptr cs:[&__it_pos_kur] ; Vel.pole < Poz.kur
     ja     Ok_VP                           ; Ano, sko ...

     mov    byte ptr cs:[&__it_pos_kur], dl ; Pozice kurzoru na obrazovce
     inc    word ptr cs:[&__it_pos_data]    ; Pozice v editovanch datech
     call   Doraz_MAX_Poz_TXT               ; Testuj max. hodnoty TXT
Ok_VP:jmp   TT_DP                           ; Tiskni text na obrazovce

;            { Ctrl + ipka pravo }
No_TRK5:
     cmp    ah, 74h                         ; Ctrl + ipka pravo ?
     jne    No_TRK6                         ; Ne, sko ...

     call   __aktual_poz_txt                ; Spotej aktuln pozice v TXT
     call   Size_TXT_to_End                 ; Spotej dlku od akt.poz.TXT do konce
     jcxz   End_Mez                         ; Je-li CX=0000, pak sko ...


;'               ******  Najdi prvn modou mezeru  ******

Hl_Mez:
     cmp    byte ptr ds:[si], ' '           ; Je mezera ?
     je     Ok_Mez                          ; Ano, sko ...

     inc    si                              ; Pozice v TXT
     inc    byte ptr cs:[&__it_pos_kur]     ; Pozice kurzoru na obrazovce
     cmp    dl, byte ptr cs:[&__it_pos_kur] ; Vel.pole < Poz.kur
     jae    No_Doraz1                       ; Ano, sko ...

     mov    byte ptr cs:[&__it_pos_kur], dl ; Poz.kur.na obrazovce na maximum
     inc    word ptr cs:[&__it_pos_data]    ; Pozice v editovanch datech
     call   __aktual_poz_txt                ; Spotej aktuln pozice v TXT

No_Doraz1:
     loop   Hl_Mez                          ; Opakuj smyku do konce TXT
     jmp    End_Mez                         ; Konec hledn ...


;'                   ******  Najdi konec mezery  ******
Ok_Mez:
     inc    si                              ; Pozice v TXT
     inc    byte ptr cs:[&__it_pos_kur]     ; Pozice kurzoru na obrazovce
     cmp    dl, byte ptr cs:[&__it_pos_kur] ; Vel.pole < Poz.kur
     ja     No_Doraz2                       ; Ano, sko ...
     mov    byte ptr cs:[&__it_pos_kur], dl ; Poz.kur.na obrazovce na maximum
     inc    word ptr cs:[&__it_pos_data]    ; Pozice v editovanch datech
     call   __aktual_poz_txt                ; Spotej aktuln pozice v TXT

No_Doraz2:
     cmp    byte ptr ds:[si], ' '           ; Je mezera ?
     jne    End_Mez                         ; Ne, sko ...
     loop   Ok_Mez                          ; Opakuj smyku do konce TXT

End_Mez:
     call   Doraz_MAX_Poz_TXT               ; Testuj max. hodnoty TXT
     jmp    TT_DP                           ; Tiskni text na obrazovce

;            { Ctrl + ipka vlevo }
No_TRK6:
     cmp    ah, 73h                         ; Ctrl + ipka vlevo ?
     jne    No_TRK7                         ; Ne, sko ...

     call   __aktual_poz_txt                ; Spotej aktuln pozice v TXT
     call   Size_TXT_to_Start               ; Spotej dlku od za. a k akt.poz.TXT
     jcxz   End_Mez1                        ; Je-li CX=0000, pak sko ...


;'                       ******  Najdi text  ******
Hl_Mez1:
     dec    si                              ; Pozice v TXT
     cmp    byte ptr ds:[si], ' '           ; Je mezera ?
     jne    Ok_Mez1                         ; Ne, sko ...
     call   Doraz_MIN_Poz_TXT               ; Testuj min. hodnoty TXT
     loop   Hl_Mez1                         ; Opakuj smyku do konce TXT
     jmp    End_Mez1                        ; Konec hledn ...


;'                  ******  Najdi zatek mezery  ******
Ok_Mez1:
     cmp    byte ptr ds:[si], ' '           ; Je mezera ?
     je     End_Mez1                        ; Ano, sko ...
     call   Doraz_MIN_Poz_TXT               ; Testuj min. hodnoty TXT
     dec    si                              ; Pozice v TXT
     loop   Ok_Mez1                         ; Opakuj smyku do konce TXT
     jmp    End_Mez1                        ; Konec hledn ...


End_Mez1:
     call   Doraz_MAX_Poz_TXT               ; Testuj max. hodnoty TXT
     jmp    TT_DP                           ; Tiskni text na obrazovce

;                  { Delete }
No_TRK7:
     cmp    ah, 53h                         ; Delete ?
     jne    No_TRK8                         ; Ne, sko ...
     call   SUB_akt_posun_TXT               ; Pithni cel text o jeden znak vlevo
     jmp    TT_DP                           ; Tiskni text na obrazovce


;                 { BackSpace }
No_TRK8:
     cmp    ah, 0Eh                         ; BackSpace  <- ?
     jne    No_TRK9                         ; Ne, sko ...
     call   Doraz_MIN_Poz_TXT               ; Testuj min. hodnoty TXT
     call   SUB_akt_posun_TXT               ; Pithni cel text o jeden znak vlevo
     jmp    TT_DP                           ; Tiskni text na obrazovce



No_TRK9:



;                     Ŀ
;                     {  Ulo naten znak do etzce  }
;                     
OUT_Str_ASCII:
     test   bl, 10000000B                   ; Je insert aktivn ?
     jz     No_Ins1                         ; Ne, sko ...
     call   INC_akt_posun_TXT               ; Odsu text o jeden znak vpravo

No_Ins1:
     call   __aktual_poz_txt                ; Spotej aktuln pozice v TXT
     mov    byte ptr ds:[si], al            ; Ulo ASCII do etzce
     mov    ah, 4Dh                         ; Simulace 'ipka vpravo'
     jmp    No_TRK4                         ; Simuluj klvesu





;                     Ŀ
;                     {  Tiskni do datovho pole text  }
;                     
TT_DP:
     mov    dx, word ptr [bp+06]                 ; Pozice text na obrazovce (1-80,1-25)
     mov    si, word ptr [bp+04]                 ; OFFSET TXT
     add    si, word ptr cs:[&__it_pos_data]     ; Pozice v editovanch datech
     dec    si                                   ; 'KOREKCE'

     mov    cx, word ptr [bp+10]                 ; Velikost zobrazenho editanho dku
     mov    ah, byte ptr cs:[&__it_color_char]   ; Barva etzce + ASCII znak vpln

     test   byte ptr cs:[&__it_setup], 10000000B ; Nastaven pro Input ...
     jz     TDP                                  ; Ne, sko ...

TDPu:mov    al, byte ptr [si]                    ; Nati znak
     inc    si
     call   word ptr cs:[&__it_user_print]       ; User proc.
     loop   TDPu                                 ; Opakuj smyku
     jmp    Kur_Pos                              ; Pesko ...

TDP: call   __video_offs_adr_t              ; Spotej VIDEO-adresu
     lodsb                                  ; Nati znak
     stosw                                  ; Tiskni znak
     inc    dh                              ; Sloupec editace (1-80) textu
     loop   TDP                             ; Opakuj smyku

;          { Umis kurzor na obrazovce }
Kur_Pos:
     mov    dx, word ptr [bp+06]            ; Pozice text na obrazovce (1-80,1-25)
     add    dh, byte ptr cs:[&__it_pos_kur] ; Sloupec editace (1-80) textu
     xchg   dh, dl                          ; Proho reg.
     dec    dl                              ;'Korekce'

     test   byte ptr cs:[&__it_setup], 01000000B ; Nastaven pro Input ...
     jz     UKOB                                 ; Ne, sko ...
     call   word ptr cs:[&__it_user_kurzor]      ; User proc.
     jmp    Pr_1                                 ; Pesko ...

UKOB:call   __set_cursor_pos                ; Nastav novou pozici kurzoru

;          { Nastav velikost kurzoru }
     test   bl, 10000000B                   ; Insert ?
     jnz    No_Ins                          ; Ne, sko ...
     mov    cx, 0010h                       ; Nastaven linky kurzoru
     call   __set_cursor_size               ; Nastav velikost kurzoru
     jmp    Pr_1

No_Ins:
     mov    cx, es
     cmp    cx, 0B000h                      ; Je to Hercules ?
     jne    No_Herc                         ; Ne, sko ...
     mov    cx, 0A0Bh                       ; Nastaven linky kurzoru
     call   __set_cursor_size               ; Nastav velikost kurzoru
     jmp    Pr_1

No_Herc:
     mov    cx, 0506h                       ; Nastaven linky kurzoru
     call   __set_cursor_size               ; Nastav velikost kurzoru

;                  { Konec }
Pr_1:
     pop    bp di si dx dx cx bx ax      ; Obnov reg.
     retn                                   ; Nvrat NEAR

 __input_text  ENDP














;                     Ŀ
;                     {   Spotej akt.pozici v TXT    }
;                     
;' Procedura pot podle pozice kurzoru na obrazovce a pozice editace v
;' TXT aktuln pozici.

;' VSTUP:  SI - aktuln pozice v TXT
;'    DX - velikost editanho dku

__aktual_poz_txt  PROC  NEAR
     push   ax
     mov    dx, word ptr [bp+10]            ; Velikost zobrazenho editanho dku
     xor    ax, ax                          ; AX = 0000
     mov    al, byte ptr cs:[&__it_pos_kur] ; Pozice kurzoru na obrazovce
     mov    si, word ptr [bp+04]            ; OFFSET TXT
     add    si, ax                          ; Adr. TXT + poz.kurzoru
     add    si, word ptr cs:[&__it_pos_data]; Adr. TXT + poz. edit.dat.
     sub    si, 2                           ;'KOREKCE
     pop    ax
     retn                                   ; Nvrat NEAR
__aktual_poz_txt  ENDP






;                     Ŀ
;                     {   Oeti min. doraz dku TXT  }
;                     
;' Procedura testuje min. dlku dku a kontroluje ji s aktuln dlkou.
;' Stane-li se, e je editace men ne ppustn min. hodnoty, vrt
;'  kurzor a pozice v edit.datech na min. monou hodnotu.

Doraz_MIN_Poz_TXT  PROC  NEAR
     dec    byte ptr cs:[&__it_pos_kur]     ; Pozice kurzoru na obrazovce
     jnz    End_Min                         ; Je-li nenulov, sko ...
     call   __aktual_poz_txt                ; Spotej aktuln pozice v TXT
     mov    byte ptr cs:[&__it_pos_kur], 1  ; Pozice kurzoru na obrazovce
     dec    word ptr cs:[&__it_pos_data]    ; Pozice v editovanch datech
     jnz    End_Min                         ; Je-li nenulov, sko ...
     call   __aktual_poz_txt                ; Spotej aktuln pozice v TXT
     mov    word ptr cs:[&__it_pos_data], 1 ; Pozice v editovanch datech

End_Min:
     retn                                   ; Nvrat NEAR
Doraz_MIN_Poz_TXT  ENDP






;                     Ŀ
;                     {   Oeti max. doraz dku TXT  }
;                     
;' Procedura spot max. dlku dku a kontroluje ji s aktuln dlkou.
;' Stane-li se, e je editace vt ne ppustn max. hodnoty, vrt
;'  kurzor a pozice v edit.datech na max. monou hodnotu.

Doraz_MAX_Poz_TXT  PROC  NEAR
     push   ax cx

     xor    ax, ax
     mov    al, byte ptr cs:[&__it_pos_kur] ; Pozice kurzoru na obrazovce
     dec    ax                              ;'KOREKCE'

     mov    cx, word ptr cs:[&__it_pos_data]; Pozice v editovanch datech
     dec    ax                              ;'KOREKCE'
     add    ax, cx

     inc    ax                              ;'KOREKCE'
     mov    dx, word ptr [bp+02]            ; Max. velikost '$' natvanch dat
     cmp    ax, dx                          ; abs.pos.dat. <= max.vel.
     jbe    No_Doraz_TXT                    ; Ano, sko ...


     dec    byte ptr cs:[&__it_pos_data]    ; Pozice v editovanch datech
     jnz    Ok_End_1
     dec    byte ptr cs:[&__it_pos_kur]     ; Pozice kurzoru na obrazovce

;'     sub    dx, word ptr [bp+10]            ; Velikost zobrazenho editanho dku
;'     mov    word ptr cs:[&__it_pos_data], dx; Pozice v editovanch datech

Ok_End_1:

No_Doraz_TXT:
     pop    cx ax
     retn                                   ; Nvrat NEAR
Doraz_MAX_Poz_TXT  ENDP






;                     Ŀ
;                     {   Poet bajt od zatku TXT   }
;                     
;' Procedura spot od zatku k aktuln pozici poet bajt.

;' VSTUP:  CX - dlka od zatku k aktuln pozice v TXT
;' 

Size_TXT_to_Start  PROC  NEAR
     push   ax
     xor    ax, ax
     mov    al, byte ptr cs:[&__it_pos_kur] ; Pozice kurzoru na obrazovce
     add    ax, word ptr cs:[&__it_pos_data]; Poz.kur. + poz.edit.dat
     mov    cx, ax
     pop    ax
     retn                                   ; Nvrat NEAR
Size_TXT_to_Start  ENDP






;                     Ŀ
;                     { Poet bajt do konce dku TXT }
;                     
;' Procedura spot od aktuln pozice poet bajt do konce textu.

;' VSTUP:  CX - dlka od aktuln pozice v TXT do konce
;' 

Size_TXT_to_End  PROC  NEAR
     push   ax
     xor    ax, ax
     mov    al, byte ptr cs:[&__it_pos_kur] ; Pozice kurzoru na obrazovce
     mov    cx, word ptr [bp+02]            ; Max. velikost '$' natvanch dat
     sub    cx, ax
     mov    ax, word ptr cs:[&__it_pos_data]; Max.vel. - poz.edit.dat
     sub    cx, ax
     inc    cx                              ;'KOREKCE - vsledn'
     pop    ax
     retn                                   ; Nvrat NEAR
Size_TXT_to_End  ENDP






;                     Ŀ
;                     {  Odsu TXT od aktuln pozice  }
;                     
;' Procedura odsune od aktuln pozice o jeden znak cel text a do konce.

INC_akt_posun_TXT  PROC  NEAR
     push   ax cx si
     call   Size_TXT_to_End                 ; Spotej dlku od akt.poz.TXT do konce

     mov    si, word ptr [bp+04]            ; OFFSET TXT
     add    si, word ptr [bp+02]            ; Konec textu
     jcxz   End_IAPT                        ; Je-li CX=0000, pak sko ...

TXT_INC:
     mov    al, byte ptr ds:[si-0002]
     mov    byte ptr ds:[si-0001], al
     dec    si
     loop   TXT_INC

End_IAPT:
     pop    si cx ax
     retn                                   ; Nvrat NEAR
INC_akt_posun_TXT  ENDP






;                     Ŀ
;                     { Pithni TXT k aktuln pozici }
;                     
;' Procedura pithne k aktuln pozice o jeden znak cel text.

SUB_akt_posun_TXT  PROC  NEAR
     push   ax cx si
     call   Size_TXT_to_End                 ; Spotej dlku od akt.poz.TXT do konce
     call   __aktual_poz_txt                ; Spotej aktuln pozice v TXT
     jcxz   End_SAPT                        ; Je-li CX=0000, pak sko ...

TXT_SUB:
     mov    al, byte ptr ds:[si+0001]
     mov    byte ptr ds:[si], al
     inc    si
     loop   TXT_SUB

End_SAPT:
     mov    byte ptr ds:[si], ' '           ; Vlo na konec mezeru
     pop    si cx ax
     retn                                   ; Nvrat NEAR
SUB_akt_posun_TXT  ENDP



Knihovna_NST32  ENDS
END
