   TITLE Test na dorazy souadnic (pro tisk znaku na obrazovku).
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   TEST_XY.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  : Procedura testuje dorazy obrazovku ...
' 

' Voln(nap.) :  mov  dl, 1               ; Zatek dku okna   (1-25)
'    mov  dh, 1               ; Zatek sloupce okna (1-80)
'                  call __test_position_xy  ; Test souadnic pro tisk

' Vstup        :  CF = 0   je to v mezch
'    CF = 1   mimo obrazovku

' Mn registry :  Flags
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __test_position_xy   ; EXTRN __test_position_xy    :PROC :NEAR
   PUBLIC &__txy_size_row      ; EXTRN &__txy_size_row       :WORD
   PUBLIC &__txy_size1_row     ; EXTRN &__txy_size1_row      :WORD
   PUBLIC &__txy_size_slow     ; EXTRN &__txy_size_slow      :BYTE

;             { Maximln dlky }
&__txy_size_row    DW 160         ; Standartn dlka dku (ATRIBUT+ASCII)
&__txy_size1_row   DW 80          ; Standartn dlka dku (ASCII)
&__txy_size_slow   DB 25          ; Max.vka okna (DORAZ)



__test_position_xy  PROC  NEAR
     push   ax                              ; Ulo reg.
     mov    ax, word ptr cs:[&__txy_size1_row]   ; Dlka dku (ASCII)
     cmp    dh, al                          ; Je dlka dku men ne DORAZ ?
     jb     OK_Row                          ; Ano, sko ...
KTD: pop    ax                              ; Obnov AX
     stc                                    ; CF = 1
     retn                                   ; Nvrat NEAR

OK_Row:
     cmp    dl, byte ptr cs:[&__txy_size_slow]   ; Je vka okna vt ne DORAZ ?
     ja     KTD                             ; Ano, sko na konec Dorazu okna ...
     pop    ax                              ; Obnov AX
     clc                                    ; CF = 0
     retn                                   ; Nvrat NEAR
__test_position_xy  ENDP

Knihovna_NST32  ENDS
END
