   TITLE Nastav VIDEO-segment pro aktuln md (+ dopln maximln dorazy).
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   V_SEG.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  : Procedura testuje aktuln md a podle vsledku nastav
'   pslun video segment a dorazy obrazovky.

' Voln(nap.) :  call __video_seg_adr     ; Zjisti VIDEO-seg. a nastav dorazy
' 
'

' Vstup        :  ES                       ; VIDEO-segment
'    &__txy_size_row          ; Poet znak na dek (ASCII+ATRIBUT)
'                  &__txy_size1_row         ; Poet znak na dek (ASCII)
'                  &__txy_size_slow         ; Poslednn dek obrazovky

' Mn registry :  Flags, ES
' 

' Odvolv se na:  TEST_XY.LIB
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __video_seg_adr      ; EXTRN __video_seg_adr       :PROC :NEAR

   EXTRN __test_position_xy    :PROC :NEAR
   EXTRN &__txy_size_row       :WORD
   EXTRN &__txy_size1_row      :WORD
   EXTRN &__txy_size_slow      :BYTE


__video_seg_adr  PROC  NEAR
     push   ax bx
     xor    ax, ax                          ; AX = 00
     mov    es, ax                          ; ES <= AX
     mov    al, byte ptr es:[0484h]         ; slo poslednho dku
     inc    al                              ;'KOREKCE
     mov    byte ptr cs:[&__txy_size_slow], al

     mov    ax, 0F00h                       ; Nati aktuln VIDEO-md
     int    10h
     and    al, 01111111B                   ; Nuluj posledn bit
     push   ax

     mov    al, ah                          ; AH = Poet znak na dek
     xor    ah, ah
     mov    word ptr cs:[&__txy_size1_row], ax   ; (ASCII)
     shl    ax, 1                           ; AX= AX * 2  
     mov    word ptr cs:[&__txy_size_row], ax    ; (ASCII+ATRIBUT)
     pop    ax                              ; AL = Aktuln md obrazovky

;       { Nastav ES na aktuln VIDEO }

     cmp    al, 7                           ; Je to hercules ?
     jne    No_Hercul                       ; Ne, sko ...
     mov    ax, 0B000h
     jmp    Ok_ES

No_Hercul:
     cmp    al, 3                           ; Je vt jak 3 ?
     ja     Grafika                         ; Ano, sko ...
     mov    ax, 0B800h                      ; CGA, EGA, VGA
     jmp    Ok_ES

Grafika:
     mov    ax, 0A000h                      ; VGA - grafika

Ok_ES:mov   es, ax                          ; Nastav ES
     pop    bx ax                           ; Obnov reg.
     retn                                   ; Nvrat NEAR
__video_seg_adr  ENDP

Knihovna_NST32  ENDS
END
