   TITLE Test na ptomnost EGA
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   D_EGA.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  : Tato procedura testuje ptomnost EGA adaptru.
' 

' Voln(nap.) :  call __detect_ega        ; Test na ptomnost EGA
' 

' Vstup        :  CF = 1  Je podporovmo EGA
'    CF = 0  Nen podporovno EGA

' Mn registry :  Flags, AX, BX
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_ega         ; EXTRN __detect_ega          :PROC :NEAR


__detect_ega  PROC  NEAR
     mov    ah, 12h
     mov    bl, 10h
     int    10h

     cmp    bl, 3
     jbe    OK_EGA
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR

OK_EGA:
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR
__detect_ega  ENDP

Knihovna_NST32  ENDS
END
