   TITLE Test na VESA BIOS
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   D_VESA.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  : Tato procedura testuje ptomnost BESA BIOSu.
' 

' Voln(nap.) :  call __detect_vesa       ; Test na ptomnost VESA BIOS
' 

' Vstup        :  CF = 1  Je instalovn VESA BIOS
'    CF = 0  Nen instalovn
'                  ES:DI   Informan blok o VESA BIOSu (256 bajt)

' Mn registry :  Flags, AX, CX, DI, ES
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_vesa        ; EXTRN __detect_vesa         :PROC :NEAR


__detect_vesa  PROC  NEAR
     mov    cx, 3                           ; 3x opakuj pokus

INIT_VESA:
     mov    di, OFFSET VESA_INFO
     mov    ax, cs
     mov    es, ax

     mov    ax, 4F00h                       ; Nati informan blok
     int    10h
     cmp    al, 4Fh                         ; Je funkce podporovna ?
     je     OK_VESA                         ; Ano, sko ...
     loop   INIT_VESA                       ; Skus to znova
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR

OK_VESA:
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR
__detect_vesa  ENDP

VESA_INFO DB 256 dup (0)

Knihovna_NST32  ENDS
END
