   TITLE Test na VGA
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   D_VGA.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  : Tato procedura testuje ptomnost VGA adaptru.
' 

' Voln(nap.) :  call __detect_vga        ; Test na ptomnost VGA
' 

' Vstup        :  CF = 1  Je podporovna VGA
'    CF = 0  Nen podporovna VGA

' Mn registry :  Flags, AX
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __detect_vga         ; EXTRN __detect_vga          :PROC :NEAR


__detect_vga  PROC  NEAR
     mov    ax, 1A00h                       ; Nati kombinaci adaptr/monitor
     int    10h

     cmp    al, 1Ah                         ; Je sluba podporovna
     jne    No_VGA                          ; Ne, sko ...
     stc                                    ; CF = 1
     retn                                   ; Nvrt NEAR

No_VGA:
     clc                                    ; CF = 0
     retn                                   ; Nvrt NEAR
__detect_vga  ENDP

Knihovna_NST32  ENDS
END
