   TITLE te znak ze zadanch souadnici
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   IN_CHAR.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  : Procedura te znak ze zadannch souadnic + kontroluje
'   "dorazy" obrazovky.

' Voln(nap.) :  mov  dl, 1               ; Znak z  dku     (1-25)
'    mov  dh, 1               ; Znak ze sloupce   (1-80)
'                  mov  es, VIDEO           ; Adr. VIDEO pamti
'                  call __in_char           ; ti znak ze souadnic X a Y

' Vstup        :  mov  ah, Color           ; Barva ASCII znaku
'    mov  al, ASCII znak      ; ASCII znak

' Mn registry :  Flags, AX
' 

' Odvolv se na:  V_OFFS_T.LIB
'    TEST_XY.LIB

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __in_char            ; EXTRN __in_char             :PROC :NEAR

   EXTRN __video_offs_adr_t    :PROC :NEAR  ; {V_OFFS_T.LIB}
   EXTRN __test_position_xy    :PROC :NEAR  ; {TEST_XY.LIB}
   EXTRN &__txy_size_row       :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size1_row      :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size_slow      :BYTE        ; {TEST_XY.LIB}


__in_char  PROC  NEAR
     push   di
     call   __test_position_xy              ; Test souadnic pro tisk
     jc     End_In_Char                     ; Jsou-li souadnice mimo
                                            ;  obrazovku, sko ...
     call   __video_offs_adr_t              ; Spotej VIDEO-adresu
     mov    ax, word ptr es:[di]            ; ti znak z obrazovky

End_In_Char:
     pop    di
     retn                                   ; Nvrat NEAR
__in_char  ENDP

Knihovna_NST32  ENDS
END
