   TITLE Pevd data z kdu kamenickch na ASCII
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   KAMEN_AS.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  :  Procedura pevede kd kamenickch na ASCII
' 

' Voln(nap.) :  mov  al, KAMEN           ; Zank pro pevod
'    call __kamen_ascii_char  ; Peve AL na ASCII

'(Voln(nap.):   mov  si, OFFSET KAMEN    ; DS:SI etzec pro pevod  )
'(   mov  cx, 100             ; Dlka etzce             )
'(                 call __kamen_ascii_text  ; Peve etzec            )

' Mn registry :  AL,   Flags, CX, DI, ES, (AX), (CX), (SI), (DI)
' 

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __kamen_ascii_char   ; EXTRN __kamen_ascii_char    :PROC :NEAR
   PUBLIC __kamen_ascii_text   ; EXTRN __kamen_ascii_text    :PROC :NEAR

   PUBLIC &__ka_tab_size_$     ; EXTRN &__ka_tab_size_$      :WORD
   PUBLIC &__ka_kamen_tab      ; EXTRN &__ka_kamen_tab       :BYTE
   PUBLIC &__ka_ascii_tab      ; EXTRN &__ka_ascii_tab       :BYTE

;    { Tabulka s kdy Kamenickch a ASCII }
&__ka_tab_size_$   DW (&__ka_ascii_tab-&__ka_kamen_tab)    ; Dlku etzce dopluje PC sm
&__ka_kamen_tab    DB '','','','','','','','','','','','',''
                   DB '','','','','','','','','','','','',''
                   DB '','','','','','','','','','',''

&__ka_ascii_tab    DB 'A','a','C','c','D','d','E','E','e','e','I','i','L'
                   DB 'L','l','l','N','n','o','O','o','R','R','r','r','S'
                   DB 's','T','t','U','U','u','u','Y','y','Z','z'



;                     Ŀ
;                     {      Peve znak na ASCII      }
;                     
__kamen_ascii_char  PROC  NEAR
     cld                                    ; Zpracovn etzc
     mov    cx, cs                          ; CX <= CS
     mov    es, cx                          ; ES <= CX
     mov    di, OFFSET &__ka_kamen_tab
     mov    cx,(&__ka_ascii_tab-&__ka_kamen_tab) ; Dlka tabulky

     repne  scasb                           ; Hledej znak v tabulce
     jne    No_KAMEN                        ; Nen-li tam, sko ...
     add    di,(&__ka_ascii_tab-&__ka_kamen_tab) ; Piti dlku tabulky (ukazuje na ASCII)
     mov    al, byte ptr cs:[di-1]          ; Vyber peveden znak
No_KAMEN:
     retn                                   ; Nvrat NEAR
__kamen_ascii_char  ENDP




;                     Ŀ
;                     {    Peve etzec na ASCII     }
;                     
__kamen_ascii_text  PROC  NEAR
     cld                                    ; Zpracovn etzc
     mov    ax, cs
     mov    es, ax                          ; ES <= CS

;            { Nati ASCII znak }
New_ASCII_T:
     push   cx                              ; Ulo dlku etzce
     lodsb                                  ; Nati znak

;           { Peve kamen/ASCII }
     mov    di, OFFSET &__ka_kamen_tab
     mov    cx,(&__ka_ascii_tab-&__ka_kamen_tab) ; Dlka tabulky
     repne  scasb                           ; Hledej znak v tabulce
     jne    No_KAMEN_T                      ; Nen-li tam, sko ...
     add    di,(&__ka_ascii_tab-&__ka_kamen_tab) ; Piti dlku tabulky (ukazuje na ASCII)
     mov    al, byte ptr cs:[di-1]          ; Vyber peveden znak
     mov    byte ptr ds:[si], al            ; Ulo peveden znak do etzce

No_KAMEN_T:
     pop    cx                              ; Obnov dlku etzce
     loop   New_ASCII_T                     ; Opakuj smyku
     retn                                   ; Nvrat NEAR
__kamen_ascii_text  ENDP

Knihovna_NST32  ENDS
END
