   TITLE Procedura edituje v Menu
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   MENU_T.ASM
  Datum prav    :   08.08.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  :  Procedura ek na stisk klesy a podle n pak pohybuje
'    s kurzorem v MENU.

' Popis dat     :
' 
'        MENU_TXT:
'        DB 2, 2     ; (+00) Pozice okna na obrazovce  '(1-25), (1-80)
'        DB 0, 0     ; (+02) 'Dopluje pota' - Velikost okna
'        DB 7        ; (+04) Poet poloek v MENU
'        DB 1        ; (+05) Prv aktivn poloka
'        DB 116      ; (+06) Barva:  1.text klvesa
'        DB 112      ; (+07)         2.text normln
'        DB 36       ; (+08)         3.text klvesa
'        DB 32       ; (+09)         4.text aktivn
'        DB 112      ; (+10)         5.barva kraje okna
'        DB 112      ; (+11)         6.barva vnitku okna
'        DW 00       ; (+12) 'Dopluje pota' - Dlka textu
'        DB 0, 0     ; (+14)
'               ---  Text je od +16  ---
'        DB 25h , ' koln data         ' ,'$'
'        DB 18h , ' Osob daje ka    ' ,'$'
'        DB 1Eh , ' Adersa ka         ' ,'$'
'        DB 13h , ' Reference na rodie ' ,'$'
'        DB 1Fh , ' Seznam  pedmt    ' ,'$'
'        DB 01h , ' Esc ... Nvrat      ' ,'$'
'                     
'                  > Znaka pro zvraznn (pouze ASCII  = 232 !!!)
'            > slo klvesy na kterou bude reagovat (SCAN kd)



' Voln(nap.) :  mov  si, OFFSET MENU_TXT ; Adr.tabulky
'    call __edit_menu_box     ; Edituj v MENU

'Vstup        :   AH = SCAN  kd znaku
'    AL = ASCII kd znaku
'                  BL = 00000000B           ; Stav dcch klves
'                       
'                       > Prav SHIFT stisknut
'                       > Lev  SHIFT stisknut
'                       >       Ctrl  stisknut
'                       >       Alt   stisknut
'                       > Scroll Lock aktivn
'                       > Num    Lock aktivn
'                       > Caps   Lock aktivn
'                       > Insert      aktivn

'                  BH = 00000000B           ; Stav rozench dcch klves
'                       
'                       > Lev  Ctrl  stisknut
'                       > Lev  Alt   stisknut
'                       > Prav Ctrl  stisknut
'                       > Prav Alt   stisknut
'                       > Scroll Lock stisknut
'                       > Num    Lock stisknut
'                       > Caps   Lock stisknut
'                       > SysRq       stisknut
'                  DL = Poet poloek v MENU
'                  DH = Prv aktivn poloka
'                  SI = 0000, pak byla schoda s oznaenou klvesou a stisknutou
'                             klvesou. Do AH je vloen kd Enteru ...

' Mn registry :  Flags, AX, BX, CX, DX, SI, DI
' 

' Odvolv se na:  R_ASCII.LIB
'    BEEP.LIB
'                  PAUSE_MS.LIB
'                  CPU_PAUS.LIB
'                  TEST_XY.LIB
'                  OUT_CHAR.LIB
'                  KAMEN_AS.LIB
'                  V_SEG.LIB
'                  V_OFFS_T.LIB
'                  SHADOW_T.LIB
'                  IN_CHAR.LIB

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __edit_menu_box      ; EXTRN __edit_menu_box       :PROC :NEAR

   EXTRN __read_ascii          :PROC :NEAR  ; {R_ASCII.LIB}
   EXTRN __num_key_convert     :PROC :NEAR  ; {R_ASCII.LIB}
   EXTRN &__ra_setup           :BYTE        ; {R_ASCII.LIB}
   EXTRN &__ra_proc_user       :WORD        ; {R_ASCII.LIB}
   EXTRN  __beep               :PROC :NEAR  ; {BEEP.LIB}
   EXTRN  __pause_ms           :PROC :NEAR  ; {PAUSE_MS.LIB}
   EXTRN  __cpu_pause          :PROC :NEAR  ; {CPU_PAUS.LIB}
   EXTRN __print_text          :PROC :NEAR  ; {PRINT_T.LIB}
   EXTRN &__pt_setup           :BYTE        ; {PRINT_T.LIB}
   EXTRN &__pt_color_char      :BYTE        ; {PRINT_T.LIB}
   EXTRN &__pt_size_tab        :BYTE        ; {PRINT_T.LIB}
   EXTRN &__pt_proc_user       :WORD        ; {PRINT_T.LIB}
   EXTRN &__pt_char_tab        :BYTE        ; {PRINT_T.LIB}
   EXTRN &__pt_color_tab       :BYTE        ; {PRINT_T.LIB}
   EXTRN &__pt_command         :BYTE        ; {PRINT_T.LIB}
   EXTRN __out_char            :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __out_char_gr         :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __new_font            :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __print_char_gr       :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __full_char_gr        :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN &__och_row_fnt        :WORD        ; {OUT_CHAR.LIB}
   EXTRN &__och_size_row       :WORD        ; {OUT_CHAR.LIB}
   EXTRN &__och_size_slow      :WORD        ; {OUT_CHAR.LIB}
   EXTRN &__och_fnt            :DWORD       ; {OUT_CHAR.LIB}
   EXTRN __kamen_ascii_char    :PROC :NEAR  ; {KAMEN_AS.LIB}
   EXTRN __kamen_ascii_text    :PROC :NEAR  ; {KAMEN_AS.LIB}
   EXTRN &__ka_tab_size_$      :WORD        ; {KAMEN_AS.LIB}
   EXTRN &__ka_kamen_tab       :BYTE        ; {KAMEN_AS.LIB}
   EXTRN &__ka_ascii_tab       :BYTE        ; {KAMEN_AS.LIB}
   EXTRN __video_seg_adr       :PROC :NEAR  ; {V_SEG.LIB}
   EXTRN __test_position_xy    :PROC :NEAR  ; {TEST_XY.LIB}
   EXTRN &__txy_size_row       :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size1_row      :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size_slow      :BYTE        ; {TEST_XY.LIB}
   EXTRN __video_offs_adr_t    :PROC :NEAR  ; {V_OFFS_T.ASM}
   EXTRN __windows             :PROC :NEAR  ; {WIN_T.LIB}
   EXTRN &__wt_setup           :BYTE        ; {WIN_T.LIB}
   EXTRN &__wt_win_typ1        :BYTE        ; {WIN_T.LIB}
   EXTRN &__wt_win_typ2        :BYTE        ; {WIN_T.LIB}
   EXTRN &__wt_c_shadow        :BYTE        ; {WIN_T.LIB}
   EXTRN &__wt_char_win        :BYTE        ; {WIN_T.LIB}
   EXTRN &_wt_proc_user_s      :WORD        ; {WIN_T.LIB}
   EXTRN &_wt_proc_user_ch     :WORD        ; {WIN_T.LIB}
   EXTRN __in_char             :PROC :NEAR  ; {IN_CHAR.LIB}
   EXTRN __out_shadow          :PROC :NEAR  ; {SHADOW_T.LIB}
   EXTRN __new_color_mod_0     :PROC :NEAR  ; {GR_UTIL.LIB}
   EXTRN __write_mod_0         :PROC :NEAR  ; {GR_UTIL.LIB}
   EXTRN __default_bios_gdc    :PROC :NEAR  ; {GR_UTIL.LIB}



;              { __edit_menu_box }
__edit_menu_box   PROC  NEAR

     mov    di, si                          ; Pomocn reg.
     mov    al, byte ptr cs:[&__ra_setup]   ; Nastaven pro Read-key
     push   ax                              ; Ulo SETUP pro KEY
     mov    byte ptr cs:[&__ra_setup], 00001000B ; Nastaven pro Read-key

     mov    al, byte ptr cs:[&__wt_setup]   ; Nastaven pro tisk okna
     push   ax                              ; Ulo SETUP .1 pro Windows
     or     byte ptr cs:[&__wt_setup], 00001100B
     mov    al, byte ptr cs:[&__wt_win_typ1]; Nastaven pro tisk okna
     push   ax                              ; Ulo SETUP .2 pro Windows
     mov    byte ptr cs:[&__wt_win_typ1], 00000011B   ; Typ okna - zkladn

;               { Zm dlku textu }
     add    si, 16                          ; Zatek textu
     xor    dx, dx                          ; DX = 0000

Size:inc    dx                              ; Nov znak
     cmp    byte ptr ds:[si], '$'           ; Je to konec ?
     je     Ok_Size                         ; Ano, sko ...
     inc    si                              ; Nov adr.
     jmp    Size                            ; Opakuj smyku

;          { Spodej dlku a vku okna }
Ok_Size:
     mov    word ptr cs:[di+12], dx         ; Dlka textu
     sub    dl, 4                           ;'KOREKCE'-rmeek-key-'$'-rmeek
     mov    byte ptr cs:[di+03], dl         ; Velikost okna (1-80)

     xor    cx, cx                          ; CX = 0000
     mov    cl, byte ptr cs:[di+04]         ; Poet poloek v MENU
     dec    cl                              ;'KOREKCE'
     mov    byte ptr cs:[di+02], cl         ; Velikost okna (1-25)

;               { Tiskni okno a text }
     mov    ax, word ptr cs:[di+10]         ; Barva
     mov    dx, word ptr cs:[di]            ; Zatek okna
     mov    cx, word ptr cs:[di+2]          ; Velikost okna
     call   __windows                       ; Tiskni okno
     call   Tiskni_TXT                      ; Tiskni text do okna




;             { ekej na stisk klvesy}
     call   __read_ascii                    ; ekej na ASCII z klvesnice
     push   bx                              ; Ulo rozenou KEY

;                  { ipka nahoru }
     cmp    ah, 48h                         ; Je to ipka nahoru ?
     jne    No_Hor                          ; Ne, sko ...
     dec    byte ptr cs:[di+05]             ; Prv aktivn poloka
     jnz    Ok_Hor
     mov    byte ptr cs:[di+05], 1          ; Prv aktivn poloka
Ok_Hor:call Tiskni_TXT                      ; Tiskni text do okna
     jmp    Ok_Konec                        ; Konec programu

;                  { ipka dolu }
No_Hor:
     cmp    ah, 50h                         ; Je to ipka dol ?
     jne    No_Dol                          ; Ne, sko ...
     inc    byte ptr cs:[di+05]             ; Prv aktivn poloka
     mov    bl, byte ptr cs:[di+04]         ; Poet poloek v MENU
     dec    bl                              ;'KOREKCE'
     cmp    bl, byte ptr cs:[di+05]         ; Prv aktivn poloka
     ja     Ok_Dol
     mov    byte ptr cs:[di+05], bl         ; Prv aktivn poloka
Ok_Dol:call Tiskni_TXT                      ; Tiskni text do okna
     jmp    Ok_Konec                        ; Konec programu

;                      { Home }
No_Dol:
     cmp    ah, 47h                         ; Je to Home ?
     jne    No_Hom                          ; Ne, sko ...
     mov    byte ptr cs:[di+05], 1          ; Prv aktivn poloka
     call   Tiskni_TXT                      ; Tiskni text do okna
     jmp    Ok_Konec                        ; Konec programu

;                       { End }
No_Hom:
     cmp    ah, 4Fh                         ; Je to End ?
     jne    No_End                          ; Ne, sko ...
     mov    al, byte ptr cs:[di+04]         ; Poet poloek v MENU
     dec    al                              ;'KOREKCE'
     mov    byte ptr cs:[di+05], al         ; Prv aktivn poloka
     call   Tiskni_TXT                      ; Tiskni text do okna
     jmp    Ok_Konec                        ; Konec programu

;             { Hledej stisknutou klvesu }
No_End:
     mov    si, di                          ; SI <= DI
     xor    dx, dx                          ; DX = 0000
     mov    cx, dx                          ; CX = 0000
     mov    cl, byte ptr cs:[di+04]         ; Poet poloek v MENU
     mov    bx, word ptr cs:[di+12]         ; Dlka textu
     add    si, 16                          ; Zatek textu

Key: inc    dx                              ; Nov znak
     cmp    byte ptr ds:[si], ah            ; Je to stisknut klvesa ?
     je     Ok_Key                          ; Ano, sko ...
     add    si, bx                          ; Dal dek
     loop   Key                             ; Opakuj smyku
     jmp    Ok_Konec                        ; Konec programu

Ok_Key:
     mov    byte ptr cs:[di+05], dl         ; Prv aktivn poloka
     call   Tiskni_TXT                      ; Tiskni text do okna
     xor    si, si                          ; Nuluj
     mov    ah, 1Ch

;             { Konec editace v MENU }
Ok_Konec:
     pop    bx                              ; Obnov rozenou KEY
     pop    cx                              ; Obnov SETUP .2 pro Windows
     mov    byte ptr cs:[&__wt_win_typ1], cl; Nastaven pro tisk okna
     pop    cx                              ; Obnov SETUP .1 pro Windows
     mov    byte ptr cs:[&__wt_setup], cl   ; Nastaven pro tisk okna
     pop    cx                              ; Obnov SETUP pro KEY
     mov    byte ptr cs:[&__ra_setup], cl   ; Nastaven pro Read-key
     mov    dx, word ptr cs:[di+4]          ; Poet a pozice poloky
     retn                                   ; Nvrat NEAR






;                     Ŀ
;                     {   Tiskni text na obrazovku     }
;                     
Tiskni_TXT:
     push   dx si bx ax                    ; Ulo reg.
     mov    si, di                          ; SI <= DI
     add    si, 16                          ; Zatek textu
     mov    dx, word ptr cs:[di]            ; Pozice okna na obrazovce  '(1-25), (1-80)
     add    dx, 0101h                       ;'KOREKCE' - Pozice textu v okn
     inc    si                              ; Zatek textu
     xor    bx, bx
     mov    bh, byte ptr cs:[di+05]         ; Prv aktivn poloka

T_Text:
     inc    bl                              ; Nov poloeka
     cmp    bl, byte ptr cs:[di+04]         ; Poet poloek v MENU
     jne    No_Pol                          ; Nejsou-li stejn, sko ...
     pop    ax bx si dx                     ; Obnov reg.
     retn


;              { Test na aktivitu dku }
No_Pol:
     cmp    bh, bl                          ; Je aktivn poloka ?
     jne    No_Aktiv                        ; Ne, sko ...
     mov    ax, word ptr cs:[di+08]         ; Aktivn barva textu
     mov    byte ptr cs:[&__pt_color_tab+22], al
     jmp    TK_OK
No_Aktiv:
     mov    ax, word ptr cs:[di+06]         ; Normln barva textu
     mov    byte ptr cs:[&__pt_color_tab+22], al

;                 { Tiskni etzec }
TK_OK:call  __print_text                    ; Tiskni text
     add    si, word ptr cs:[di+12]         ; Nov adr. textu
     inc    dl                              ; Nov dek
     jmp    T_Text

__edit_menu_box  ENDP


Knihovna_NST32  ENDS
END
