   TITLE Procedura tiskne stn v textovm reimu.
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   SHADOW_T.ASM
  Datum prav    :   01.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  :  Tiskne stn.  Video-adresu si spot ze
'    aktulnch souadnic.

' Voln(nap.) :  mov  ah, Barva           ; Barva stnu
'    mov  dl, 1               ; Pozice dku stnu   (1-25)
'                  mov  dh, 1               ; Pozice sloupce stnu (1-80)
'                  call __out_shadow        ; Tiskni stn

'Vstup        :   DH = Zatek sloupce okna (1-80) + 1
'


' Mn registry :  Flags
' 

' Odvolv se na:  V_OFFS_T.LIB
'    TEST_XY.LIB
'                  OUT_CHAR.LIB
'                  IN_CHAR.LIB

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __out_shadow         ; EXTRN __out_shadow          :PROC :NEAR

   EXTRN __out_char            :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __in_char             :PROC :NEAR  ; {IN_CHAR.LIB}
   EXTRN __test_position_xy    :PROC :NEAR  ; {TEST_XY.LIB}
   EXTRN &__txy_size_row       :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size1_row      :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size_slow      :BYTE        ; {TEST_XY.LIB}
   EXTRN __video_offs_adr_t    :PROC :NEAR  ; {V_OFFS_T.LIB}


__out_shadow  PROC  NEAR
     push   bx ax                           ; Ulo reg.
     mov    bh, ah                          ; Pesu barvu
     call   __in_char
     mov    ah, bh                          ; Obnov barvu
     call   __out_char                      ; Tiskni znak na souadnice X a Y
     pop    ax bx                           ; Obnov reg.
     retn                                   ; Nvrat NEAR
__out_shadow  ENDP

Knihovna_NST32  ENDS
END
