   TITLE Procedura tiskne okno v textovm reimu
   .8086                               ; Linkuje se pro 80 86
   PAGE 67, 130                        ; Strnka 67 zn., dlka 130 zn./dek









   COMMENT @
{

  Nzev souboru  :   WIN_T.ASM
  Datum prav    :   23.03.95
  Verze programu :   3.05
  (c) Copyright  :   1995 by NST 32 , Medo Zdenk junior

 }

' Popis funkce  :  Windows tiskne v textovm reimu okna na monitor.
' 

' Voln(nap.) :  mov  ah, 14              ; Barva textu uvnit okna
'    mov  al, 21              ; Barva rmeku
'                  mov  dl, 10              ; Zatek dku okna   (1-25)
'                  mov  dh, 50              ; Zatek sloupce okna (1-80)
'                  mov  cl, 7               ; Vka okna  (1-23)
'                  mov  ch, 20              ; Dlka okna  (1-78)
'                  call __windows           ; Tiskni okno

' Mn registry :  Flags
' 

' Odvolv se na:  SHADOW_T.LIB
'    TEST_XY.LIB
'                  OUT_CHAR.LIB
'                  IN_CHAR.LIB
'                  V_SEG.LIB
'                  V_OFFS_T.LIB

'@
Knihovna_NST32  SEGMENT BYTE PUBLIC 'CODE' USE16
   ASSUME CS:Knihovna_NST32

   PUBLIC __windows            ; EXTRN __windows             :PROC :NEAR
   PUBLIC &__wt_setup          ; EXTRN &__wt_setup           :BYTE
   PUBLIC &__wt_win_typ1       ; EXTRN &__wt_win_typ1        :BYTE
   PUBLIC &__wt_win_typ2       ; EXTRN &__wt_win_typ2        :BYTE
   PUBLIC &__wt_c_shadow       ; EXTRN &__wt_c_shadow        :BYTE
   PUBLIC &__wt_char_win       ; EXTRN &__wt_char_win        :BYTE
   PUBLIC &_wt_proc_user_s     ; EXTRN &_wt_proc_user_s      :WORD
   PUBLIC &_wt_proc_user_ch    ; EXTRN &_wt_proc_user_ch     :WORD

   EXTRN __test_position_xy    :PROC :NEAR  ; {TEST_XY.LIB}
   EXTRN &__txy_size_row       :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size1_row      :WORD        ; {TEST_XY.LIB}
   EXTRN &__txy_size_slow      :BYTE        ; {TEST_XY.LIB}
   EXTRN __out_char            :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __out_char_gr         :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __new_font            :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __print_char_gr       :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN __full_char_gr        :PROC :NEAR  ; {OUT_CHAR.LIB}
   EXTRN &__och_row_fnt        :WORD        ; {OUT_CHAR.LIB}
   EXTRN &__och_size_row       :WORD        ; {OUT_CHAR.LIB}
   EXTRN &__och_size_slow      :WORD        ; {OUT_CHAR.LIB}
   EXTRN &__och_fnt            :DWORD       ; {OUT_CHAR.LIB}
   EXTRN __in_char             :PROC :NEAR  ; {IN_CHAR.LIB}
   EXTRN __out_shadow          :PROC :NEAR  ; {SHADOW_T.LIB}
   EXTRN __video_seg_adr       :PROC :NEAR  ; {V_SEG.LIB}
   EXTRN __video_offs_adr_t    :PROC :NEAR  ; {V_OFFS_T.ASM}
   EXTRN __new_color_mod_0     :PROC :NEAR  ; {GR_UTIL.LIB}
   EXTRN __write_mod_0         :PROC :NEAR  ; {GR_UTIL.LIB}
   EXTRN __default_bios_gdc    :PROC :NEAR  ; {GR_UTIL.LIB}



;        { Nastaven parametr v SETUPu }
&__wt_setup    DB 00001100B  ; Nastaven pro tisk okna
               ;' 
               ;' > 1 = Tisknout stn pod okno (color .8)
               ;' > 1 = Tisknout vnitek okna
               ;' > rezervovno
               ;' > rezervovno
               ;' > 1 = Pouvat jinou proc.pro tisk okna
               ;' > 1 = Pouvat jinou proc.pro tisk stnu

&__wt_win_typ1 DB 00000000B  ; Typ okna - zkladn
               ;' 
               ;'   > Typ rmeku: 000 = ˻
               ;'                        001 = Ѹ
               ;'                        010 = ҷ
               ;'                        011 = ¿
               ;'                        100 = 
               ;' > rezervovno
               ;' > Lev Horn Roh ............ 
               ;' > Prav Horn Roh ......... 
               ;' > Lev Doln Roh ........ 
               ;' > Prav Doln Roh ..... 

&__wt_win_typ2 DB 00000000B  ; Typ okna - rozen
               ;' 
               ;' > Lev Horn Roh ............ 
               ;' > Lev Horn Roh .......... 
               ;' > Prav Horn Roh ....... 
               ;' > Prav Horn Roh ..... 
               ;' > Lev Doln Roh ............ 
               ;' > Lev Doln Roh .......... 
               ;' > Prav Doln Roh ....... 
               ;' > Prav Doln Roh ..... 

&__wt_c_shadow     DB 8      ; Barva stnu pod oknem
&__wt_char_win     DB ' '    ; Vpl okna
&_wt_proc_user_s   DW OFFSET Navrat
&_wt_proc_user_ch  DW OFFSET Navrat
Navrat:            RETN

;            { Mon tvary okna }
Typ_Okna           DB '','','','','','','','','',   '','',''
                   DB '','','','','','','','','',   '','',''
                   DB '','','','','','','','','',   '','',''
                   DB '','','','','','','','','',   '','',''
                   DB '','','','','','','','','',   '','',''
;'                                                         
;'                                                         
;'  Lev Horn Roh  <                                    
;'          SI+01   <                                 
;'  Prav Horn Roh <                              
;'          SI+03   <                           
;'          SI+04   <                        
;'          SI+05   <                     
;'  Lev Doln Roh  <                  
;'          SI+07   <               
;'  Prav Doln Roh <            
;'          SI+09                             Horn dek  <      
;'          SI+10                     Lev a Prav Strana  <   
;'          SI+11                             Doln dek  <

__windows  PROC  NEAR
     cld                                    ; Zpracovn etzc

     push   ax                    ; (+17=AH) Barva textu uvnit okna
                                  ; (+16=AL) Barva rmeku
     push   bx                    ; (+14=BX)
     push   cx                    ; (+13=CH) Dlka okna (1-78)
                                  ; (+12=CL) Vka okna (1-23)
     push   dx                    ; (+11=DH) Zatek sloupce okna (1-80)
                                  ; (+10=DL) Zatek dku okna   (1-25)
     push   si                    ; (+08=SI)
     push   di                    ; (+06=DI)
     push   bp                    ; (+04=BP)
     push   ds                    ; (+02=DS)
     push   es                    ; (+00=ES)

     mov    ax, cs
     mov    ds, ax                          ; DS <= CS
     mov    bp, sp                          ; Vrchol zsobnku

     dec    dl                              ;'KOREKCE' - 1 dek
     dec    dh                              ;'KOREKCE' - 1 sloupec
     mov    bh, dh                          ; Doasn schova sloupce okna (1-80)

     mov    di, word ptr [&__wt_win_typ1]   ; Obsah tabulek [&__wt_win_typ1] a [&__wt_win_typ2] do AX
                                            ; DI=Kopie LO=[&__wt_win_typ1], HI=[&__wt_win_typ2]
     mov    bl, byte ptr [bp+17]            ; BL = Pomocn barva uvnit okna

     call __video_seg_adr                   ; Zjisti VIDEO-adresu a nastav dorazy

;            { Test na Typ Okna }
     mov    ax, di                          ; Typ rmeku
     and    al, 00000111B                   ; Oezej slo
     mov    si, OFFSET Typ_Okna             ; Nastav standartn '˻'

     cmp    al, 1                           ; Je to okno 'Ѹ' ?
     jne    No_Win_1                        ; Ne, sko ...
     mov    si, OFFSET Typ_Okna+12          ; Adr. tvaru okna
     jmp    OK_Win                          ; Sko

No_Win_1:
     cmp    al, 2                           ; Je to okno 'ҷ' ?
     jne    No_Win_2                        ; Ne, sko ...
     mov    si, OFFSET Typ_Okna+24          ; Adr. tvaru okna
     jmp    OK_Win                          ; Sko

No_Win_2:
     cmp    al, 3                           ; Je to okno '¿' ?
     jne    No_Win_3                        ; Ne, sko ...
     mov    si, OFFSET Typ_Okna+36          ; Adr. tvaru okna
     jmp    OK_Win                          ; Sko

No_Win_3:
     cmp    al, 4                           ; Je to okno '' ?
     jne    OK_Win                          ; Ne, sko ...
     mov    si, OFFSET Typ_Okna+48          ; Adr. tvaru okna
     jmp    OK_Win                          ; Sko


;                     Ŀ
;                     {    Tiskni Horn st okna      }
;                     
OK_Win:
     mov    al, byte ptr [si]               ; Nastav standartn ''

     test   di, 0000000100000000B           ; Je to ''
     jz     No_LHR_1                        ; Ne, sko ...
     mov    al, byte ptr [si+03]            ; ASCII = ''
     jmp    Tisk_LHR                        ; Tiskni Lev Horn Roh

No_LHR_1:
     test   di, 0000001000000000B           ; Je to ''
     jz     No_LHR_2                        ; Ne, sko ...
     mov    al, byte ptr [si+01]            ; ASCII = ''
     jmp    Tisk_LHR                        ; Tiskni Lev Horn Roh

No_LHR_2:
     test   di, 000000000010000B            ; Je to ''
     jz     Tisk_LHR                        ; Ne, sko ...
     mov    al, byte ptr [si+04]            ; ASCII = ''

Tisk_LHR:
     mov    ah, byte ptr [bp+16]            ; Barva rmeku
     call   __wt_out_char                   ; Tiskni znak na souadnice X a Y

;         { Tiskni Horn Rovnou ru }
     xor    cx, cx
     mov    cl, byte ptr [bp+13]            ; Dlka okna
     mov    al, byte ptr [si+09]            ; ASCII = '-'
THRC:call   __wt_out_char                   ; Tiskni znak na souadnice X a Y
     loop   THRC

;         { Tiskni Prav Horn Roh }
     mov    al, byte ptr [si+02]            ; Nastav standartn ''

     test   di, 0000010000000000B           ; Je to ''
     jz     No_PHR_1                        ; Ne, sko ...
     mov    al, byte ptr [si+05]            ; ASCII = ''
     jmp    Tisk_PHR                        ; Tiskni Prav Horn Roh

No_PHR_1:
     test   di, 0000100000000000B           ; Je to ''
     jz     No_PHR_2                        ; Ne, sko ...
     mov    al, byte ptr [si+01]            ; ASCII = ''
     jmp    Tisk_PHR                        ; Tiskni Prav Horn Roh

No_PHR_2:
     test   di, 000000000100000B            ; Je to ''
     jz     Tisk_PHR                        ; Ne, sko ...
     mov    al, byte ptr [si+04]            ; ASCII = ''

Tisk_PHR:
     call   __wt_out_char                   ; Tiskni znak na souadnice X a Y


;                     Ŀ
;                     {   Tiskni Stedn st okna     }
;                     

;        { Tiskni Stedn Levou ru }
     mov    dh, bh                          ; Obnov pozice znaku (sloupec okna 1-80)
     inc    dl                              ; Sko o dek n
     xor    cx, cx                          ; Pomocn vka okna (1-23)
     mov    cl, byte ptr [bp+12]            ; Vka okna
     jcxz   LDR                             ; Je-li nula, sok ...

Sted:push  cx                              ; Ulo vku okna
     mov    al, byte ptr [si+10]            ; ASCII = '' - Lev strana
     call   __wt_out_char                   ; Tiskni znak na souadnice X a Y

;           { Tiskni Sted Okna }
     mov    al, byte ptr [&__wt_char_win]   ; Vpl okna
     xchg   bl, ah                          ; Vmna barev
     mov    cl, byte ptr [bp+13]            ; Dlka okna

     test   byte ptr [&__wt_setup], 00001000B    ; Tisknout vnitek okna ?
     jnz    TSO                             ; Ano, sko ...
     add    dh, cl                          ; Posu kurzor, jako by se tisklo okno
     jmp    NTSO                            ; Sko bez tisku vnitku okna

TSO: call   __wt_out_char                   ; Tiskni znak na souadnice X a Y
     loop   TSO

;        { Tiskni Sted Pravou ru }
NTSO:xchg   bl, ah                          ; Vmna barev
     mov    al, byte ptr [si+10]            ; ASCII = '' - Prav strana
     call   __wt_out_char                   ; Tiskni znak na souadnice X a Y

     test   byte ptr [&__wt_setup], 00000100B    ; Je zapnut stn ?
     jz     No_Stn_1                       ; Ne, sko ...
     call   __wt_out_shadow                 ; Tiskni stn
     call   __wt_out_shadow                 ; Tiskni stn

No_Stn_1:
     mov    dh, bh                          ; Obnov pozice znaku (sloupec okna 1-80)
     inc    dl                              ; Sko o dek n
     pop    cx                              ; Obnov pomocnou vku okna
     loop   Sted                           ; Opakuj tisk dku


;                     Ŀ
;                     {    Tiskni Doln st okna      }
;                     
LDR: mov    al, byte ptr [si+06]            ; Nastav standartn ''

     test   di, 0001000000000000B           ; Je to ''
     jz     No_LDR_1                        ; Ne, sko ...
     mov    al, byte ptr [si+03]            ; ASCII = ''
     jmp    Tisk_LDR                        ; Tiskni Lev Doln Roh

No_LDR_1:
     test   di, 0010000000000000B           ; Je to ''
     jz     No_LDR_2                        ; Ne, sko ...
     mov    al, byte ptr [si+07]            ; ASCII = ''
     jmp    Tisk_LDR                        ; Tiskni Lev Doln Roh

No_LDR_2:
     test   di, 000000001000000B            ; Je to ''
     jz     Tisk_LDR                        ; Ne, sko ...
     mov    al, byte ptr [si+04]            ; ASCII = ''

Tisk_LDR:
     call   __wt_out_char                      ; Tiskni znak

;        { Tiskni Doln Rovnou ru }
     mov    cl, byte ptr [bp+13]            ; Dlka okna
     mov    al, byte ptr [si+11]            ; ASCII = '-'
TDRC:call   __wt_out_char                   ; Tiskni znak na souadnice X a Y
     loop   TDRC

;         { Tiskni Prav Doln Roh }

PDR: mov    al, byte ptr [si+08]            ; Nastav standartn ''

     test   di, 0100000000000000B           ; Je to ''
     jz     No_PDR_1                        ; Ne, sko ...
     mov    al, byte ptr [si+05]            ; ASCII = ''
     jmp    Tisk_PDR                        ; Tiskni Prav Doln Roh

No_PDR_1:
     test   di, 1000000000000000B           ; Je to ''
     jz     No_PDR_2                        ; Ne, sko ...
     mov    al, byte ptr [si+07]            ; ASCII = ''
     jmp    Tisk_PDR                        ; Tiskni Prav Doln Roh

No_PDR_2:
     test   di, 000000010000000B            ; Je to ''
     jz     Tisk_PDR                        ; Ne, sko ...
     mov    al, byte ptr [si+04]            ; ASCII = ''

Tisk_PDR:
     call   __wt_out_char                   ; Tiskni znak na souadnice X a Y

     test   byte ptr [&__wt_setup], 00000100B    ; Je zapnut stn ?
     jz     Windows_End                     ; Ne, sko ...
     call   __wt_out_shadow                 ; Tiskni stn
     call   __wt_out_shadow                 ; Tiskni stn

     mov    dh, bh                          ; Obnov pozice znaku (sloupec 1-80)
     inc    dl                              ; Sko o dek n
     add    dh, 2                           ; Posu zatek stnu o 2 znaky vpravo
     mov    cl, byte ptr [bp+13]            ; Dlka okna
     add    cx, 2                           ; Prodlu stn o 2 znaky

DKS: call   __wt_out_shadow                 ; Tiskni stn
     loop   DKS

;              { Konec Windows }
Windows_End:
     pop    es ds bp di si dx cx bx ax      ; Obnov reg.
     retn                                   ; Nvrat NEAR

__windows ENDP






; Ŀ
; {                  P  O  D  P  R  O  G  R  A  M  Y                      }
; 

;                     Ŀ
;                     {         Tiskni Stn            }
;                     
;'Upravuje proceduru pro tisk stu.
;
;'VSTUP:    DL = Zatek dku okna   (1-25)
;'    DH = Zatek sloupce okna (1-80)
;
;'VSTUP:   DH = Zatek sloupce okna (1-80) + 1
;'

__wt_out_shadow  PROC  NEAR
     push   ax                              ; Ulo reg.
     mov    ah, byte ptr [&__wt_c_shadow]   ; Barva stnu pod oknem

     test   byte ptr [&__wt_setup], 10000000B    ; Zapnut User proc. ?
     jz     No_User_1                       ; Ne, sko ...
     call   word ptr cs:[&_wt_proc_user_s]  ; Uivatelsk proc.
     jmp    End_Shadow

No_User_1:
     call   __out_shadow                    ; Tiskni stn
End_Shadow:
     pop    ax                              ; Obnov reg.
     retn                                   ; Nvrat NEAR
__wt_out_shadow  ENDP




;                     Ŀ
;                     {         Tiskni Znak            }
;                     
;'Upravuje proceduru pro tisk ASCII znaku.
;
;'VSTUP:    AH = Barva ASCII znaku
;'    AL = ASCII znak
;'          DL = Zatek dku okna   (1-25)
;'          DH = Zatek sloupce okna (1-80)
;'          ES = VIDEO Adr.
;
;'VSTUP:   DH = Zatek sloupce okna (1-80) + 1
;'

__wt_out_char  PROC  NEAR
     test   byte ptr [&__wt_setup], 01000000B    ; Zapnut User proc. ?
     jz     No_User_2                       ; Ne, sko ...
     call   word ptr cs:[&_wt_proc_user_ch] ; Uivatelsk proc.
     retn                                   ; Nvrat NEAR

No_User_2:
     call   __out_char                      ; Tiskni znak na souadnice X a Y
     retn                                   ; Nvrat NEAR
__wt_out_char  ENDP


Knihovna_NST32  ENDS
END
